//      
const express = require("express");
const path = require('path');
const fs = require('fs');
const constants = fs.constants;
const valid = require('./modules/valid');
//const compression = require('compression');
const os = require('os');
const net = require('net');
const bodyParser = require('body-parser');
const exec = require('child_process').exec;


//const process = require("process");
const ini = require("ini");
const _ = require('underscore');
const sysinfo = require("./modules/sysinfo");
const maintenance = require("./modules/maintenance");
const datetime = require("./modules/datetime");
const network = require("./modules/network");
const firmware = require("./modules/firmware");
const users = require("./modules/users");
const logprocess = require("./modules/logprocess");
const packets = require("./modules/packets");
const tps = require("./modules/tps");
const agg = require("./modules/agg");
const backres = require("./modules/backres");
const gprs = require("./modules/gprs");
const wifi = require("./modules/wifi");
const rmdir = require('rimraf');
const ftp = require('ftp');
//const TFTP = require('tftp-client');
//const tftp = require('tftp');
const myTftp = require('./modules/tftp');
//const ss = require('socket.io-stream');
//const dl = require('delivery');
//const net = require('net');
const modules = {
    'wifi': require("./modules/wifi"),
    'sysInfo': require("./modules/sysinfo"),
    'gprs': require("./modules/gprs"),
    'filemanager': require("./modules/filemanager"),
    'systemd': require('./modules/systemd'),
    'tios': require('./modules/tios'),
    'checking': require('./modules/checking'),
    'packets': require('./modules/packets'),
    'agg':require('./modules/agg'),
    'fileTransfer':require('./modules/fileTransfer'),
    'maintenance':require('./modules/maintenance')
};
const app = express();
// var server = require('http').Server(app);
// import * as http from "http"
const http = require('http');
let server = http.createServer(app);

var io = require('socket.io')(server);

var shellescape = require("shell-escape");

var async = require('async');

var port = 3210;

var socket_global;
/*
 * uss
 * */
let timeZoneList=[];
datetime.getTimezonesList().then((list)=>{
    timeZoneList=list;
});
var exist = fs.existsSync('/var/run/wan.sock');

if (exist) {
    fs.unlink('/var/run/wan.sock',() => {

    });
}

const serverUnix = net.createServer(function (c) {
    console.log('client connected');
    c.on('end', function () {
        console.log('client disconnected');
    });
    c.on('data', function (data) {

        let res = valid.valid(data.toString());
        res = _.uniq(res);
        if (res.length > 0) {
            var str = res.map(function (item) {
                return item;
            }).join('\n');
        } else {
            str = 'INF[]= validation successful!'
        }
        c.write(str);
        //console.log(res);
        c.end();
    });
    c.on('error', function (err) {
        console.log(err);
    });
});
serverUnix.on('close', function () {
    console.log('server close');
});
serverUnix.listen('/var/run/wan.sock', function () {
    console.log('server bound');
});
/*
 * end0 uss
 * */


io.on('connection', function (socket) {
    socket_global = socket;
    var aggStatus;
    var gprsStatus;
    var wifiStatus;
    var tiosStatus;
    var getInfoAndSend = function () {
        sysinfo.getSysInfo()
            .then(function (sysinfo) {

                socket.emit('sysinfo:update', sysinfo);
            })
            .catch(function (e) {
                socket.emit('sysinfo:error', {code: "unable-to-get-fs"});
            });
    };

    getInfoAndSend();
    var getAggregateStatus = function () {

    };
    /* var wifiScanTimer = setInterval(function(){
     if(wifiStatus){
     getWifiStatus()
     }
     }, 10000);*/
    var sysInfoTimer = setInterval(function () {
        getInfoAndSend();
        // console.log('tios status if',tiosStatus);
        if (aggStatus == true) {
            //console.log('alive');

            //agg.statusServer();
            //agg.statusAgent();
            Promise.all([agg.statusServer(), agg.statusAgent()])
                .then(function (values) {
                    socket.emit('agg:status', {server: values[0], agent: values[1]});
                })
                .catch(function () {
                    socket.emit('agg:error', 'unable-get-status')
                })


        }
        if (gprsStatus) {
            getGprsStatus();
        }
        if(tiosStatus){
            // console.log('getTiOsStatus()');
            getTiOsStatus()
        }
    }, 5000);
    var getGprsStatus = function () {
        gprs.status().then(function (res) {
            socket.emit('gprs:status:get', res);
        });

    };
    var getTiOsStatus=function(){
        modules.tios.status().then(function(res){
            // console.log('tios status',res);
            socket.emit('tios:status',res);
        })
    };
    var getWifiStatus = function (first) {
        wifi.getAccessPoint().then(function (res) {
            //console.log(res);
            if (first) {
                res = res.map(function (item) {
                    item.show = false;
                    return item;
                });
            }
            socket.emit('wifi:res:savedAccessPoint', res);
        });
        wifi.getCurrRegion()
            .then(function (res) {
                socket.emit('wifi:res:currRegion', res);
            })
            .catch(err => {
                console.log(err)
            })
    };
    var timeDateCtlStatus = function () {
        datetime.timeDateCtlStatus().then(
            function (info) {
                socket.emit("datetime:timeInfoArrived", info);
            },
            function () {
                socket.emit("datetime:error", {code: "unable-to-get-current-zone"});
            }
        )
    };

    var printEnv = function () {
        firmware.printEnv().then(
            function (data) {
                socket.emit("firmware:printenvComplete", data);
            },
            function () {
                socket.emit("firmware:error", {code: "unable-to-get"});
            }
        )
    };
    socket.on('agg:status', function (value) {
        aggStatus = value;
        Promise.all([agg.statusServer(), agg.statusAgent()])
            .then(function (values) {
                socket.emit('agg:status', {server: values[0], agent: values[1]});
            })
            .catch(function () {
                socket.emit('agg:error', 'unable-get-status')
            });

        //console.log(value);
    });

    /* var delivery = dl.listen(socket);
     /!*
     * upload file
     * *!/
     delivery.on('receive.success', function (file) {
     //console.log(global.process);
     var params = file.params;
     fs.writeFile(file.name, file.bufer, function (err) {
     if (err) {
     console.log('File could not be saved.')
     } else {
     console.log('File saved.');
     }
     });
     });
     /!*
     * download file
     * *!/
     socket.on('router',function(data){
     regexpModule=/^[a-z0-9\-]*$/;
     if(regexpModule.test(data.moduleName)){
     //console.log('work');
     var module=require(data.moduleName);

     }else{
     console.log('bad module!');
     }
     });
     socket.on('download:file', function () {
     console.log('downloading');
     delivery.send({
     name: 'sample-image.jpg',
     path: './' + path.basename('123png.png'),
     params: {foo: 'bar'}
     });

     delivery.on('send.success', function (file) {
     console.log('File successfully sent to client!');
     });
     /!*delivery.on('delivery.connect',function(delivery){



     });*!/
     });*/

    /*ss(socket).on('test-download', function(stream) {
     console.log('downloading');
     var file=__dirname+'/backup/'+path.basename('command.sh');
     fs.createReadStream(file).pipe(stream);
     });
     ss(socket).on('test-upload', function (stream, data) {
     //console.log(data,stream);
     var filename = __dirname+'/backup'+path.basename(data.name);
     console.log(filename);
     stream.pipe(fs.createWriteStream(filename))
     });*/

    socket.on("network:list", () => {
        network.getNetworkList()
            .then(result => {
                socket.emit("network:list", result);
            })
    });

    socket.on('gprs:status', function (val) {
        gprsStatus = val;
        getGprsStatus()
    });
    socket.on('wifi:status', function (val) {
        wifiStatus = val;
        getWifiStatus(true);
    });
    socket.on('tios:status', function (val) {
        tiosStatus = val;
        /*getTiOsStatus(true);*/
        getTiOsStatus();
    });
    var trIt=0;
    socket.on('transfer',function(data){
        socket.emit('testtransfer');
        /*if(trIt>=20){
            setTimeout(function(){
                trIt=0;
                // console.log('transfer');
                socket.emit('testtransfer');
            },1000);
        }else{
            socket.emit('testtransfer');
            trIt++;
        }*/
    });
    socket.on('newRouting', function (data) {
        // console.time(data.module+' '+data.method);

        // console.log('newRouting all',data);
        if (data.module in modules) {
            // console.log(data.module,data.method);
            if (data.method in modules[data.module]) {
                // console.log('work');
                modules[data.module][data.method](data.data,socket).then(function (res) {
                    // console.log('newRouting',res);
                    // console.timeEnd(data.module+' '+data.method);
                    socket.emit(data.return, res);
                }).catch(function (e) {
                    console.log(e);
                });

            }
        }

    });
    /*socket.on('newRoutingAsync', function (data) {
        if (data.module in modules) {
            if (data.method in modules[data.module]) {
                modules[data.module][data.method](data.data, io).then(function (res) {
                    console.log(res);
                })
            }
        }
    });*/
    socket.on('agg:restart', function (value) {
        if (value == 'server' || value == 'agent') {
            agg.restart(value)
                .then(function () {
                    socket.emit('agg:restart:ok')
                })
                .catch(function () {
                    socket.emit('agg:restart:error', 'something-wrong');
                })
        } else {
            socket.emit('agg:error', 'invalid-services-name')
        }
    });
    socket.on('tftp:download', function (data) {
        var tftpObj = {};
        var segments = data.url.replace('tftp://', '').split('/');
        var hostData = segments[0];
        if (/:\d+/.test(hostData)) {
            var tmpHostData = hostData.split(':');
            tftpObj.port = tmpHostData[1];
            tftpObj.host = tmpHostData[0];
        } else {
            tftpObj.host = hostData;
            tftpObj.port = 69;
        }
        segments.shift();
        var file = segments.join('/');
        var fileName = segments.pop();
        var client = new myTftp(tftpObj.port, tftpObj.host, {'tsize': 0, 'blksize': 30000});
        var writeByte = 0;
        var fd = fs.openSync(data.currPath + '/' + fileName, 'w+', constants.O_SYNC | constants.O_DIRECT);
        var offset = 0;
        var fullSize = 0;
        var count = 0;
        var mem = 0;
        client.read(file, function (err, tftpData) {
            count++;
            var r = fs.writeSync(fd, tftpData.chunk, 0, tftpData.chunk.length, offset);
            writeByte += r;
            fullSize = tftpData.fileSize;
            if (r >= 0 && r != tftpData.chunk.length) {
                console.log('bad writing file, stop transfer and deleting file');
                fs.closeSync(fd);
                fs.unlink(data.currPath + '/' + fileName);
            }
            if (r >= 0) {
                offset += r;
            }
            if (writeByte == tftpData.fileSize) {
                fs.closeSync(fd);
                socket.emit('filemanager:file:progress', {'continue': false});
                clearInterval(tftpInterval);
            }
            if (count > 200) {
                mem = process.memoryUsage();
                if (mem.rss > 40000) {
                    //console.log('gC');
                    global.gc();
                }
                count = 0;
            }
            if (err) {
                return;
            }
        });
        var tftpInterval = setInterval(function () {
            socket.emit('filemanager:file:progress', {
                'continue': true,
                "writen": writeByte,
                'fullSize': fullSize,
                'fileName': fileName
            });
        }, 1000);
    });
    socket.on('http:download', function (data) {
        var segments = data.url.replace('http://', '').split('/');
        //var hostname = segments[0];
        var fileName = segments.pop();
        var writeByte = 0;
        segments.shift();
        var fd = fs.openSync(data.currPath + '/' + fileName, 'w+', constants.O_SYNC | constants.O_DIRECT);
        var offset = 0;
        var count = 0;
        http.get(data.url, function (res) {
            var fullSize = res.headers['content-length'];
            var interval = setInterval(function () {
                socket.emit('filemanager:file:progress', {
                    'continue': true,
                    "writen": writeByte,
                    'fullSize': fullSize,
                    'fileName': fileName
                });
            }, 1000);
            res.on('data', function (d) {
                    count++;
                    var r = fs.writeSync(fd, d, 0, d.length, offset);
                    writeByte += r;
                    if (r >= 0 && r != d.length) {
                        console.log('bad writing file, stop transfer and deleting file');
                        fs.closeSync(fd);
                        fs.unlink(data.currPath + '/' + fileName);
                    }
                    if (r >= 0) {
                        offset += r;
                    }
                    if (writeByte == fullSize) {
                        fs.closeSync(fd);
                        socket.emit('filemanager:file:progress', {'continue': false});
                        clearInterval(interval);
                    }
                    // delete d;
                    res.read();
                    if (count > 200) {
                        res.pause();
                        setTimeout(function () {

                            global.gc();
                            res.resume();
                            count = 0;
                        }, 100);
                    }
                    return true;
                })
                .on('close', function () {
                    //console.log('close')
                })
        });

    });
    socket.on('ftp:download', function (data) {
        var ftpObj = {};
        var segments = data.url.replace('ftp://', '').split('/');
        var hostData = segments[0];
        hostData = hostData.split('@');
        var auth;
        if (hostData.length > 1) {
            auth = hostData[0].split(':');
            if (auth.length > 1) {
                ftpObj.user = auth[0];
                ftpObj.password = auth[1];
            } else {
                ftpObj.user = auth;
            }
            ftpObj.host = hostData[1];
        } else {
            ftpObj.host = hostData;
        }
        segments.shift();
        var file = segments.join('/');
        var fileName = segments.pop();
        var client = ftp();
        var fileSize;
        client.on('error', function (err) {
            console.log('error');
        });
        client.on('ready', function () {
            client.list(file, function (err, list) {

                //console.log('now here');
                fileSize = list[0].size;
                client.end();
            });
            client.binary(function (test, test2) {
                client.end();
            });
            client.get(file, function (err, stream) {
                stream.once('close', function () {
                    socket.emit('filemanager:file:progress', {'continue': false});
                    clearInterval(interval);
                    global.gc();
                    client.end();
                });
                var count = 0;
                var writeByte = 0;
                var offset = 0;
                var fd = fs.openSync(data.currPath + '/' + fileName, 'w+', constants.O_SYNC | constants.O_DIRECT);
                stream.on('data', function (d) {
                    count++;
                    var r = fs.writeSync(fd, d, 0, d.length, offset);
                    writeByte += r;
                    if (r >= 0 && r != d.length) {
                        console.log('bad writing file, stop transfer and deleting file');
                        fs.closeSync(fd);
                        fs.unlink(data.currPath + '/' + fileName);
                    }
                    if (r >= 0) {
                        offset += r;
                    }
                    if (writeByte == fileSize) {
                        fs.closeSync(fd);
                        global.gc();
                        socket.emit('filemanager:file:progress', {'continue': false});
                        clearInterval(interval);
                    }
                    stream.read();
                    // delete d;
                    if (count > 100) {
                        stream.pause();
                        setTimeout(function () {

                            global.gc();
                            stream.resume();
                            count = 0;
                        }, 100);
                    }
                });
                var interval = setInterval(function () {
                    socket.emit('filemanager:file:progress', {
                        'continue': true,
                        "writen": writeByte,
                        'fullSize': fileSize,
                        'fileName': fileName
                    });
                }, 1000)
            })
        });

        client.connect(ftpObj);


    });
    socket.on('filesending', function (file) {

    });
    socket.on('agg:stop', function (value) {

        if (value == 'server' || value == 'agent') {

            agg.stop(value)
                .then(function () {
                    socket.emit('agg:stop:ok')
                })
                .catch(function () {
                    //console.log(value);
                    socket.emit('agg:stop:error', 'something-wrong');
                })
        } else {
            socket.emit('agg:error', 'invalid-services-name')
        }

        //agg.restart()
    });
    socket.on('backres:getBackupData', function () {

        var details = backres.getBackUpDetails();
        //console.log('app result details',details);
        socket.emit('backres:getBackupData', details);
    });
    socket.on('backres:confreboot', function (data) {
        //console.log('app',data);
        var res = backres.confReboot(data);
        res.then(function (res) {
            if (res == 'confirm') {
                socket.emit('backres:successConfirm')
            }
        }, function (e) {
            console.log('somesthin wrong', e);
        }).catch(function (err) {
            console.log(err);
        });
    });
    socket.on("sysinfo:devicetree", function () {
        sysinfo.getDeviceTree().then(
            function (data) {
                socket.emit("sysinfo:devicetree", data.toString());
            },
            function () {
                socket.emit("sysinfo:error", {code: "unable-to-get-devicetree"});
            }
        )
    });

    socket.on("sysinfo:release", function () {
        sysinfo.getReleaseInfo()
            .then(function (data) {
                socket.emit('sysinfo:release', data);
            })
            .catch(function (e) {
                socket.emit('sysinfo:error', {code: "unable-to-get-release"});
            })
    });

    socket.on("sysinfo:settings", function () {
        fs.readFile("./resources/settings.json", (err, data) => {
            if(!err){
                socket.emit('sysinfo:settings', data.toString());
            }
        })
    });

    socket.on("tps:config", function () {
        tps.TPSInfo().then(
            function (data) {
                socket.emit("tps:ok", data);
            },
            function () {
                socket.emit("tps:error", {code: "unable-to-get"});
            }
        )
    });

    socket.on("fullConfiguration:get", function () {
        Promise.all([
            datetime.timeDateCtlStatus(),
            datetime.getNTP()
        ]).then(function (values) {
            var output = {
                datetime: values[0],
                ntp: values[1]
            };
            var filename = "/download/configuration.json";
            var json = JSON.stringify(output, null, "    ");
            fs.writeFile(__dirname + filename, json, function (err) {
                if (err !== null) {
                    socket.emit("maintenance:error", {code: "config"});
                } else {
                    socket.emit("maintenance:config", {filename: filename});
                }
            })
        });
    });

    socket.on("log:get", function (data) {
        logprocess.getLog(socket, data);
    });
    socket.on('maintenance:regenerateSshKey', function () {
        //console.log('here');
        maintenance.regenerateSshKey().then(function () {
            console.log('all ssh  key was die!!!')
        })
    });
    socket.on("maintenance:reboot", function () {
        maintenance.reboot();
    });
    socket.on("maintenance:changeFirstSerial", function (val) {
        maintenance.changeFirstSerial(val);
    });
    socket.on('maintenance:getConsoleEnv', function () {

        maintenance.envConsole().then(function (res) {
            socket.emit('maintenance:consoleEnv', res);
        });

    });
    socket.on("maintenance:buzz", function () {
        maintenance.buzz().then(
            function () {
            },
            function (error) {
                socket.emit("maintenance:error", {code: "buzz"});
            }
        );
    });

    socket.on("datetime:getTimezonesList", function () {
        socket.emit("datetime:timezonesListArrived", {list: timeZoneList});
        /*datetime.getTimezonesList().then(
            function (list) {
                socket.emit("datetime:timezonesListArrived", {list: list})
            },
            function () {
                socket.emit("datetime:error", {code: "unable-to-get-timezones"});
            }
        );*/
    });

    socket.on("datetime:setDateTime", function (data) {
        datetime.setDateTime(data).then(
            function () {
                socket.emit("datetime:ok", {code: "set-time"});
                timeDateCtlStatus();
            },
            function () {
                socket.emit("datetime:error", {code: "unable-to-set-time"});
            }
        )
    });

    socket.on("datetime:getNTP", function () {
        datetime.getNTP().then(
            function (output) {
                socket.emit("datetime:ntpArrived", output);
            },
            function () {
                socket.emit("datetime:error", {code: "unable-to-get-ntp"});
            }
        )
    });

    socket.on("datetime:updateNTP", function (data) {
        datetime.updateNTP(data).then(
            function () {
                socket.emit("datetime:ok", {code: "set-ntp"});
                timeDateCtlStatus();
            },
            function () {
                socket.emit("datetime:error", {code: "unable-to-set-ntp"});
            }
        )
    });

    socket.on("datetime:getCurrentTimeInfo", function () {
        timeDateCtlStatus();
    });

    socket.on("datetime:setCurrentTimezone", function (data) {
        datetime.setCurrentTimezone(data).then(
            function () {
                socket.emit("datetime:ok", {code: "set-zone"});
                timeDateCtlStatus();
            },
            function (error) {
                socket.emit("datetime:error", {code: "unable-to-set-zone"});
            }
        )
    });

    socket.on("datetime:systohc", function () {
        datetime.sysToHc().then(
            function () {
                socket.emit("datetime:ok", {code: "systohc"});
                timeDateCtlStatus();
            },
            function (error) {
                socket.emit("datetime:error", {code: "unable-to-sync"});
            }
        )
    });

    socket.on("network:get", function (data) {

        network.get('eth0').then(
            function (eth0) {
                network.get('eth1')
                    .then(eth1 => socket.emit("network:dataArrived", {eth0, eth1}))
                    .catch(err => socket.emit("network:dataArrived", {eth0, eth1: null}))
            }
        ).catch(function () {
            socket.emit("network:error", {code: "unable-to-get"});
        })
    });

    //TODO:test

    socket.on("network:set", function (data) {
        network.set(data).then(
            function () {
                socket.emit("network:ok", {code: "set"});
            },
            function () {
                socket.emit("network:error", {code: "unable-to-set"})
            }
        )
    });

    socket.on("network:getMac", function (data) {
        network.getMac(data).then(
            function (mac) {
                socket.emit("network:mac", {iface: data, mac: mac});
            },
            function () {
                socket.emit("network:error", {code: "unable-to-get-mac"});
            }
        )
    });

    //TODO:test

    socket.on("network:setMac", function (data) {
        network.setMac(data).then(
            function () {
                socket.emit("network:ok", {code: "mac-set"});
            },
            function () {
                socket.emit("network:error", {code: "unable-to-set-mac"});
            }
        )
    });

    socket.on("maintenance:restartWebServer", function () {
        maintenance.restartWebServer();
    });

    socket.on("firmware:printenv", function () {
        printEnv();
    });


    socket.on("firmware:setenv", function (data) {
        firmware.setEnv(data).then(
            function () {
                socket.emit("firmware:setenvComplete");
                printEnv();
            },
            function () {
                socket.emit("firmware:error", {code: "unable-to-set"});
            }
        )
    });

    var getSystemUserList = function () {
        users.getSystemUserList().then(
            function (result) {
                socket.emit("users:system:get", result);
            },
            function () {
                socket.emit("users:system:error", {code: "unable-to-get", error: "READ"});
            }
        )
    };

    socket.on("users:system:get", function () {
        getSystemUserList();
    });

    socket.on("users:system:set", function (data) {
        users.usersSystemSet(data)
            .then(
                function (code) {
                    socket.emit("users:system:ok", {code: code});
                    getSystemUserList();
                }
            )
            .catch(
                function (error) {
                    socket.emit("users:system:error", {code: error.message})
                }
            )
    });

    var listChannels = function () {
        packets.listChannels()
            .then(
                function (list) {
                    socket.emit("packets:channels:list", list);
                }
            )
            .catch(
                function (error) {
                    socket.emit("packets:channels:error", {code: "unable-to-list"})
                }
            )
    };

    socket.on("packets:channel:add", function (data) {
        packets.addChannel(data)
            .then(
                function () {
                    socket.emit("packets:channels:ok", {code: "add"});
                    listChannels();
                }
            )
            .catch(
                function (error) {
                    socket.emit("packets:channels:error", {code: "unable-to-add", msg: error.message})
                }
            )
    });

    socket.on("packets:channel:remove", function (data) {
        packets.removeChannel(data)
            .then(
                function () {
                    socket.emit("packets:channels:ok", {code: "remove"});
                    listChannels();
                }
            )
            .catch(
                function (error) {
                    socket.emit("packets:channels:error", {code: "unable-to-remove"})
                }
            )
    });

    socket.on("packets:channel:list", function () {
        listChannels();
    });

    socket.on("users:web:set", function (data) {
        users.usersWebSet(socket, data);
    });

    socket.on("agg:get", function (data) {
        agg.get(data)
            .then(
                function (data) {
                    socket.emit("agg:get", data);
                }
            )
            .catch(
                function (error) {
                    socket.emit("agg:error", {code: "unable-to-get"})
                }
            )
    });

    socket.on("agg:set", function (data) {
        agg.set(data)
            .then(
                function () {
                    socket.emit("agg:ok", {code: "set"});
                }
            )
            .catch(
                function (error) {
                    socket.emit("agg:error", {code: "unable-to-set"})
                }
            )
    });

    socket.on("disconnect", function () {
        logprocess.killLogProcess();
        clearInterval(sysInfoTimer);
    });
    socket.on('backRes:backup', function (data) {
        backres.newBackup(data).then(function (filename) {
            socket.emit('backRes:ok', {filename: filename})
        }).catch(function () {
            socket.emit('backRes:err')
        })
    })
});

var Busboy = require('busboy');

app
    .use(bodyParser.json())
    .use(express.static('./root'))
    .use("/js", express.static('./root/js'))
    .use("/backup", express.static('./backup'))
    .use("/css", express.static('./root/css'))
    .use("/images", express.static('./root/images'))
    .use("/fonts", express.static('./root/fonts'))
    .post("/backup/upload", function (req, res, next) {
        var busboy = new Busboy({headers: req.headers});


        var stream;
        var filenameG;
        busboy.on('file', function (fieldname, file, filename) {
            //socket.emit('backres:busboy:response','sssssss');
            filename = "/tmp/" + filename;
            filenameG = filename;
            var reg = /^.*\.tar\.gz$/;
            if (reg.test(filename)) {
                //var saveFile=return new Promise(function(resolve,reject){
                stream = fs.createWriteStream(filename);
                stream.on('error', function (e) {
                    res.status(500).send("").end();
                });
                var testStream = file.pipe(stream);
                testStream.on('finish', function () {

                    if (stream.truncated) {

                        res.status(413).send("").end()
                    } else {
                        rmdir('/tmp/confrestore/*', function (err) {
                            if (err) {
                                console.log(err);
                            }
                            else {
                                exec('mkdir -p /tmp/confrestore && tar -xvf "' + filenameG + '" -C /tmp/confrestore/',
                                    function (error, stdout, stderr) {
                                        if (error !== null || stderr !== "") {
                                            console.log(error, stdout, stderr);
                                            res.status(413).send("").end();
                                        }
                                        else {
                                            res.status(200).send('').end();
                                        }

                                    }
                                );
                            }
                        });

                    }
                });
                //});


            } else {
                res.status(413).send("").end();
            }
        });
        req.pipe(busboy);
    })
    .post("/license/upload", function (req, res, next) {
        // console.log('post req with file receive');
        var busboy = new Busboy({headers: req.headers});
        var stream;
        var filenameG;
        busboy.on('file', function (fieldname, file, filename) {
            //socket.emit('backres:busboy:response','sssssss');
            filename = "/opt/AggreGate/" + filename;
            filenameG = filename;
            var reg = /server\.license/;
            if (reg.test(filename)) {
                //var saveFile=return new Promise(function(resolve,reject){
                stream = fs.createWriteStream(filename);
                stream.on('error', function (e) {
                    res.status(500).send("").end();
                });
                var testStream = file.pipe(stream);
                testStream.on('finish', function () {
                    if (stream.truncated) {
                        res.status(413).send("").end()
                    } else {
                        exec('systemctl restart ag_server',function(err,stdout,stderr){
                            if(err){
                                res.status(413).send("").end();
                            }else {
                                res.status(200).send('').end();
                            }
                        });
                        /*rmdir('/tmp/confrestore/!*', function (err) {
                         if (err) {
                         console.log(err);
                         }
                         else {
                         exec('mkdir -p /tmp/confrestore && tar -xvf "' + filenameG + '" -C /tmp/confrestore/',
                         function (error, stdout, stderr) {
                         if (error !== null || stderr !== "") {
                         console.log(error, stdout, stderr);
                         res.status(413).send("").end();
                         }
                         else {
                         res.status(200).send('').end();
                         }

                         }
                         );
                         }
                         });*/
                    }
                });
            } else {
                res.status(413).send("").end();
            }
        });
        req.pipe(busboy);
    })
   /* .post("/license/upload", function (req, res, next) {
        // console.log('post req with file receive');
        var busboy = new Busboy({headers: req.headers});
        var stream;
        var filenameG;
        busboy.on('file', function (fieldname, file, filename) {
            //socket.emit('backres:busboy:response','sssssss');
            filename = "/opt/AggreGate/" + filename;
            filenameG = filename;
            var reg = /server\.license/;
            if (reg.test(filename)) {
                //var saveFile=return new Promise(function(resolve,reject){
                stream = fs.createWriteStream(filename);
                stream.on('error', function (e) {
                    res.status(500).send("").end();
                });
                var testStream = file.pipe(stream);
                testStream.on('finish', function () {

                    if (stream.truncated) {
                        res.status(413).send("").end()
                    } else {
                        res.status(200).send('').end();
                        /!*rmdir('/tmp/confrestore/!*', function (err) {
                            if (err) {
                                console.log(err);
                            }
                            else {
                                exec('mkdir -p /tmp/confrestore && tar -xvf "' + filenameG + '" -C /tmp/confrestore/',
                                    function (error, stdout, stderr) {
                                        if (error !== null || stderr !== "") {
                                            console.log(error, stdout, stderr);
                                            res.status(413).send("").end();
                                        }
                                        else {
                                            res.status(200).send('').end();
                                        }

                                    }
                                );
                            }
                        });*!/
                    }
                });
            } else {
                res.status(413).send("").end();
            }
        });
        req.pipe(busboy);
    })*/
    .post("/build/io.html", function (req, res) {
        var busboy = new Busboy({headers: req.headers});
        var params = {};
        var path = "/var/www/tps-wan/site/root/mod-www-builder/";
        busboy.on('field', function (fieldname, val) {
            params[fieldname] = val;
        });
        busboy.on('finish', function () {

            //TODO: Make async
            if (params.func == "list") {
                try {
                    var output = {};

                    var readDirPromise = function (dirname) {
                        return new Promise(function (resolve, reject) {
                            fs.readdir(dirname, function (err, data) {
                                if (err !== null) {
                                    reject()
                                } else {
                                    resolve(data)
                                }
                            })
                        })
                    };

                    var tibbits = fs.readdirSync(path + "txt_Devices/tibbits");
                    var boards = fs.readdirSync(path + "txt_Devices/boards");
                    var tibbits_desc = fs.readdirSync(path + "txt_Devices/tibbits-desc");

                    tibbits.forEach(function (file) {
                        output["tibbits/" + file] = {f_type: "T", r: true, w: false}
                    });
                    boards.forEach(function (file) {
                        if (file[0] == 'l') {
                            output["boards/" + file] = {f_type: "B", r: true, w: false}
                        }
                    });
                    tibbits_desc.forEach(function (file) {
                        output["tibbits-desc/" + file] = {f_type: "T-d", r: true, w: false}
                    });

                    output['current.ini'] = {f_type: "P", r: true, w: true};
                    var perms = {
                        login: "ltps@tibbo.com",
                        role: "supervisor"
                    };

                    res.writeHead(200, {'Content-Type': 'application/json'});
                    res.write(JSON.stringify({files: output, perms: perms}));
                    res.end();
                } catch (e) {
                    res.status(500).send("").end();
                }
            } else if (params.func == "read") {
                try {
                    var result = [];
                    //console.log(params);
                    Object.keys(params).forEach(function (key) {
                        if (/^file[[0-9]+]$/.test(key)) {
                            var filename = params[key];
                            var content;
                            if (filename !== "current.ini") {
                                var full_filename = path + "txt_Devices/" + filename;
                                if ( !fs.lstatSync( full_filename).isFile()) return;
                                content = fs.readFileSync( full_filename);
                            } else {
                                content = fs.readFileSync("/opt/tps-shared/hwini/current.ini");
                            }
                            result.push({
                                f_name: filename,
                                plain: content.toString()
                            })
                        }
                    });
                    res.writeHead(200, {'Content-Type': 'application/json'});
                    res.write(JSON.stringify(result));
                    res.end();
                } catch (e) {
                    res.status(500).send("").end();
                }
            } else if (params.func == "write") {
                try {
                    var content = params.data;
                    //console.log(params.data);

                    fs.writeFileSync("/tmp/current.ini", content);
                    exec('/opt/tps-dts/conv.sh /tmp/current.ini',
                        function (error, stdout, stderr) {
                            if (/*error!==0 ||*/ error !== null) {
                                //console.log("ERR", error, stderr, stdout);
                                res.writeHead(200, {'Content-Type': 'application/json'});
                                res.write(JSON.stringify({err: stdout}));
                            } else {
                                res.writeHead(200, {'Content-Type': 'application/json'});
                                res.write(JSON.stringify(["current.ini"]));
                            }
                            res.end();
                        }
                    )
                } catch (e) {
                    res.status(500).send("").end();
                }
            }
        });
        req.pipe(busboy);
    })
    .post("/wificert-upload/",function(req,res){
        // console.log(req.headers)
        console.log('router for wifi upload work');
        let busboy = new Busboy({headers:req.headers})
        console.log(req.params);
        busboy.on("file",function(fieldname,file,filename){
            console.log(fieldname,filename);

            let filenameG = "/etc/wpa_supplicant/certs/" + filename;

            let stream = fs.createWriteStream(filenameG);
            stream.on('error', function (e) {
                res.status(500).send("").end();
            });
            file.pipe(stream);
        })
        busboy.on('field', function(fieldname, val, fieldnameTruncated, valTruncated, encoding, mimetype) {
            console.log('Field [' + fieldname + ']: value: ' + inspect(val));
        });
        busboy.on('finish', function() {
            console.log('Done parsing form!');
            // res.writeHead(303, { Connection: 'close', Location: '/' });

            res.status(200).send("").end();
            res.end();
        });
        req.pipe(busboy);
    })
    .post("/resources/upload-configuration", function (req, res, next) {
        var busboy = new Busboy({headers: req.headers});

        var stream;
        //var filename = __dirname+"/uploads/hwconf.dtb";
        var filenameG;
        busboy.on('file', function (fieldname, file, filename) {
            filenameG = "/tmp/" + filename;

            stream = fs.createWriteStream(filenameG);
            stream.on('error', function (e) {
                res.status(500).send("").end();
            });
            file.pipe(stream);
        });

        busboy.on('finish', function () {
            //console.log('finish');
            if (stream.truncated) {
                res.status(413).send("").end();
            } else {
                var command = shellescape(['/opt/tps-dts/conv.sh', filenameG]);
                exec(command,
                    function (error, stdout, stderr) {
                        if (/*error!==0 ||*/ error !== null) {
                            console.log(error, stderr, stdout);
                            res.status(415).send({error: error, stedrr: stderr}).end();
                        } else {

                            res.status(200).send("").end();
                        }
                    }
                );
            }
        });

        req.pipe(busboy);
    })
    .use(function (req, res) {
        res
            .status(404)
            .sendFile('/service/404.html', {root: __dirname});
    });
server
    .listen({"port":port,host:'localhost'},function () {
        console.log("Listening at :" + port);
    });
