var exec = require('child_process').exec;
var shellescape = require("shell-escape");
var ini = require("ini");
var fs = require('fs');

exports.get = function () {
    return new Promise(function (resolve, reject) {
        fs.readFile("/opt/tpsagent/etc/tpsagent.conf", function (error, data) {

            if (error !== null) {
                reject(Error("unable-to-get"));
            } else {
                var output = ini.parse(data.toString());
                resolve(output);
            }
        })
    });
};

// TODO: Selectively modify only the 'AggreGate' section
exports.getActivationKey=function () {
    return new Promise(function(resolve,reject){
        fs.exists('/opt/AggreGate/activation.txt',function(exist){
            if(exist){
                fs.readFile('/opt/AggreGate/activation.txt',function(err,data){
                    if(err){
                        console.log(err);
                    }else{
                        resolve(data.toString());
                    }
                })
            }else{
                reject(Error('unable-to-get'))
            }
        })
    })
};
exports.set = function (data) {
    return new Promise(function (resolve, reject) {
        try {
            var serialized = ini.encode(data, {whitespace: true});
        } catch (e) {
            reject(Error("unable-to-encode"));
        }
        fs.writeFile("/opt/tpsagent/etc/tpsagent.conf", serialized, function (error) {
            if (error) {
                reject(Error("unable-to-set"));
            }
            else {
                exec('/bin/systemctl restart tps-agent',
                    function (error, stdout, stderr) {
                        if (error !== null) {
                            reject(Error("unable-to-reload"));
                        } else {
                            resolve();
                        }
                    }
                )
            }
        })
    });
};
exports.statusAgent = function () {
    return new Promise(function (resolve, reject) {
        exec('/bin/systemctl status tps-agent',
            function (error, stdout, stderr) {

                try {
                    var re = /^\s*Active:\s(\w*)/m;
                    var status = re.exec(stdout);

                    //console.log('agent', status[1]);
                    resolve(status[1]);
                } catch (e) {
                    reject(Error("unable-to-parse-status"));
                }

            }
        )
    });

};
//exports.watchAgent=function

exports.statusServer = function () {
    return new Promise(function (resolve, reject) {
        exec('/bin/systemctl status ag_server',
            function (error, stdout, stderr) {

                try {
                    var re = /^\s*Active:\s(\w*)/m;
                    var status = re.exec(stdout);
                    //console.log('server', status[1]);
                    resolve(status[1]);
                } catch (e) {
                    reject(Error("unable-to-parse-status"));
                }

            }
        )
    });

};
exports.restart = function (val) {
    return new Promise(function(resolve,reject){
        var serviceName
        if(val=='agent'){
            serviceName='tps-agent';
        }
        if(val=='server'){
            serviceName='ag_server';
        }
        //console.log('controller',val,serviceName);
       /* var command='/bin/systemctl restart '+serviceName;
        console.log(command);*/
        exec('/bin/systemctl restart '+serviceName,function(error,stdout,stderr){
            if(error!==null){
                //console.log(error,stdout,stderr);
                reject(Error("something-wrong"));
            }else{
                resolve();
            }
        })
    })
};
exports.stop = function (val) {
    return new Promise(function(resolve,reject){
        var serviceName;

        if(val=='agent'){
            serviceName='tps-agent';
        }
        if(val=='server'){
            serviceName='ag_server';
        }
        //console.log('controller',val,serviceName);
        exec('/bin/systemctl stop '+serviceName,function(error,stdout,stderr){
            if(error!==null){
                reject(Error("something-wrong"));
            }else{
                resolve();
            }
        })
    })
};