/**
 * Created by stts on 23.03.2016.
 */
var exec = require('child_process').exec;
var fs = require('fs');
//var shellescape = require("shell-escape");
var async = require('async');
var os = require('os');
var rmdir = require('rimraf');

var getBackUpDetails = function () {
    var files = {
        "network": {
            name: 'Network Configuration',
            files: ['network.sh', 'network.tar.gz']
        },
        "wifi": {
            name: 'Wifi Configuration',
            files: [
                'wifi.sh',
                'wifi.tar.gz'
            ]
        },
        "gprs": {
            name: 'GPRS Configuration',
            files: [
                'gprs.sh',
                'gprs.tar.gz'
            ]
        },
        "timeDate": {
            name: 'Time / Date Settings',
            files: ['timeDate.sh', 'timeDate.tar.gz']
        },
        "aggregateAgent": {
            name: 'AggreGate Agent',
            files: ['aggregateAgent.sh', 'aggregateAgent.tar.gz']
        },
        "aggregateServer": {
            name: 'AggreGate Server',
            files: ['aggregateServer.sh', 'aggregareServer.tar.gz']
        },
        "tios": {
            name: 'TiOS',
            files: ['TiOS.sh', 'TiOS.tar.gz']
        },
        "custom": {
            name: 'Custom',
            files: ['custom.sh', 'custom.tar.gz']
        }
    };
    var backupList = Object.keys(files).map(function (key) {
        if (Array.isArray(files[key].files)) {
            var res = false;
            files[key].files.forEach(function (item) {
                var exist = fs.existsSync('/tmp/confrestore/backup/' + item);
                if (exist && !res) {
                    res = true;
                }
            });

            if (res) {
                return {key:key,name:files[key].name}
            }
            //console.log(res);
        }
        /*else {
            var exist = fs.existsSync('/tmp/confrestore' + files[key]);
            if (exist) {
                return key;
            }
        }*/
    }).filter(function (item) {
        if (item !== undefined) {
            return item;
        }
    });
    //console.log(backupList);
    return backupList;
};
var newBackup = function (defs) {
    return new Promise(function (resolve, reject) {
        // console.log('some thing',defs);
        var files = {
            "network": '/etc/systemd/network/*',
            "wifi": [
                '/etc/wpa_supplicant/*',
                '/etc/modprobe.d/cfg80211.conf'
            ],
            "gprs": [
                '/etc/ppp/*',
                '/etc/chatscripts/*'
            ],
            "timeDate": '/etc/systemd/timesyncd.conf',
            "aggregateAgent": '/opt/tpsagent/etc/*',
            "aggregateServer": '/opt/AggreGate/data/properties/*',
            "tios":'/opt/tps-tios/var'
        };
        var commands = {
            'network': {
                'pre': '',
                'in': '',
                'post': '/bin/systemctl restart systemd-networkd'
            },
            'wifi': {
                'pre': '',
                'in': '',
                'post': '/bin/systemctl restart tps-wpa@wlan0'
            },
            'gprs': {
                'pre': '/bin/systemctl stop ppp@*',
                'in': '',
                'post': ''
            },
            'timeDate': {
                'pre': '',
                'in': '',
                'post': '/bin/systemctl restart systemd-timedated'
            },
            'aggregateAgent': {
                'pre': '',
                'in': '',
                'post': '/bin/systemctl restart tps-agent'
            },
            'aggregateServer': {
                'pre': '/bin/systemctl stop ag_server',
                'in': '',
                'post': '/bin/systemctl restart ag_server'
            },
            'tios':{
                'pre':'',
                'in':'',
                'post':''
            }
        };
        var hostname = os.hostname();
        var date = new Date();
        var customDate = function (date) {
            if (date < 10) {
                return '0' + date;
            } else {
                return date;
            }
        };
        var currDate =
            date.getFullYear() + '-'
            + customDate(date.getMonth()) + '-'
            + customDate(date.getDate()) + ' '
            + customDate(date.getHours()) + ':'
            + customDate(date.getMinutes()) + ':'
            + customDate(date.getSeconds());
        var fileName = hostname + '.' + currDate;
        rmdir(__dirname + '/../backup/*', function (err) {
            if (err) {
                console.log(err);
            } else {
                try {
                    var promises = Object.keys(defs).map(function (key) {
                        return new Promise(function (resolve, reject) {
                            if (defs[key] == true) {
                                // var tmpPromise;
                                try{
                                    // console.log('defs true');
                                    if (Array.isArray(files[key])) {
                                        // console.log('is array');
                                            var tmpPromise=function(){
                                                return new Promise(function(resolve,recject){
                                                var str = files[key].map(function (item) {
                                                    return item;
                                                }).filter(function (item) {
                                                    var exist = fs.existsSync(item.replace(/\*$/, ''));
                                                    if (exist) {
                                                        return item;
                                                    }
                                                }).join(' ');
                                                // console.log('cd ' + __dirname + '/../backup; tar -czf "./' + key + '.tar.gz" ' + str+ ' && sync');
                                                exec('cd ' + __dirname + '/../backup; tar -czf "./' + key + '.tar.gz" ' + str, function (error, stdout, stderr) {
                                                    if (error !== null) {
                                                        console.log(error, stdout, stderr);
                                                        reject()
                                                    }else{
                                                        resolve();
                                                    }
                                                });
                                            })
                                        };
                                    } else {
                                        // console.log('not array');
                                            var tmpPromise=function(){
                                            return new Promise(function (resolve,reject) {
                                                // console.log('or here');
                                                var exist = fs.existsSync(files[key].replace(/\*$/, ''));
                                                if (exist) {
                                                    // console.log('cd ' + __dirname + '/../backup; tar -czf "./' + key + '.tar.gz" ' + files[key]+' && sync');
                                                    exec('cd ' + __dirname + '/../backup; tar -czf "./' + key + '.tar.gz" ' + files[key], function (error, stdout, stderr) {
                                                        if (error !== null) {
                                                            console.log(error, stdout, stderr);
                                                            reject();
                                                        }else{
                                                            resolve()
                                                        }
                                                    });
                                                }else{
                                                    reject()
                                                }
                                            })
                                        };
                                    }
                                    tmpPromise().then(function(){
                                        // console.log('promise all');
                                        var preCommand = '';
                                        var inCommand = '';
                                        var postCommand = '';
                                        if (Array.isArray(commands[key].pre)) {
                                            preCommand += commands[key].pre.join(' && ');
                                        } else {
                                            preCommand += commands[key].pre;
                                        }
                                        if (Array.isArray(commands[key].in)) {
                                            inCommand += commands[key].in.join(' && ');
                                        } else {
                                            inCommand += commands[key].in;
                                        }
                                        if (Array.isArray(commands[key].post)) {
                                            postCommand += commands[key].post.join(' && ');
                                        } else {
                                            postCommand += commands[key].post;
                                        }
                                        if (preCommand != '') {
                                            preCommand = preCommand + ' && '
                                        }
                                        if (postCommand != '') {
                                            postCommand = ' && ' + postCommand;
                                        }
                                        var commandStr = '#!/bin/sh\n cd /tmp/confrestore/backup/ && mkdir ' + key + ' && ' + preCommand + ' tar -xvf "./' + key + '.tar.gz" -C /tmp/confrestore/backup/' + key + ' && /usr/bin/rsync -ap /tmp/confrestore/backup/' + key +'/ / ' + postCommand;
                                        fs.writeFileSync(__dirname + '/../backup/' + key + '.sh', commandStr);
                                        // console.log('work in here');
                                        resolve();
                                    });
                                }catch(e){
                                   console.log(e);
                                }

                            }
                        });

                    });
                    Promise.all(promises).then(function () {
                        // console.log('here');
                        var names = Object.keys(defs).map(function (key) {
                            if (defs[key] == true) {
                                var str = __dirname + '/../backup/' + key + '.sh ' + __dirname + '/../backup/' + key + '.tar.gz';
                                return str
                            }
                        }).filter(function (item) {
                            return item !== undefined;
                        });
                        // console.log('cd ' + __dirname + '/../backup; tar -czf "./' + fileName + '.tar.gz" ' + names.join(' '));
                        exec('cd ' + __dirname + '/../backup; tar -czf "./' + fileName + '.tar.gz" ' + names.join(' '), function (error, stdout, stderr) {
                            if (error !== null) {
                                // console.log(error, stdout, stderr);
                                reject(Error("unable-to-zip"))
                            } else {
                                resolve(fileName);
                            }
                        });
                    })
                } catch (err) {
                    // console.log(err);
                }
            }
        });
    });
};
var backup = function (defs) {
    return new Promise(function (resolve, reject) {

        var files = {
            "network": '/etc/systemd/network/*',
            "wifi": [
                '/etc/wpa_supplicant/*',
                '/etc/modprobe.d/cfg80211.conf'
            ],
            "gprs": [
                '/etc/ppp/*',
                '/etc/chatscripts/*'
            ],
            "timeDate": '/etc/systemd/timesyncd.conf',
            "aggregateAgent": '/opt/tpsagent/etc/*',
            "aggregateServer": '/opt/AggreGate/data/properties/*'
        };
        var commands = {
            "network": {

                "value": '/bin/systemctl restart systemd-networkd',
                "turn": 2
            },
            "timeDate": {
                "value": '/bin/systemctl restart systemd-timedated',
                "turn": 3
            },
            "aggregateAgent": {
                "value": '/bin/systemctl restart tps-agent',
                "turn": 4
            },
            "aggregateServer": {
                "value": '/bin/systemctl stop ag_server',
                "turn": 1
            }
        };
        var hostname = os.hostname();
        var date = new Date();
        var customDate = function (date) {
            if (date < 10) {
                return '0' + date;
            } else {
                return date;
            }
        };
        var currDate =
            date.getFullYear() + '-'
            + customDate(date.getMonth()) + '-'
            + customDate(date.getDate()) + ' '
            + customDate(date.getHours()) + ':'
            + customDate(date.getMinutes()) + ':'
            + customDate(date.getSeconds());
        var fileName = hostname + '.' + currDate;
        try {
            var args = Object.keys(defs).map(function (key) {
                if (defs[key] == true) {
                    if (exist) {
                        if (Array.isArray(files[key])) {
                            return files[key].join(' ');
                        } else {
                            return files[key];
                        }
                    }
                }
            }).filter(function (file) {
                return file !== undefined;
            }).join(' ');
            var strArgs = args.split(' ').map(function (file) {
                var exist = fs.existsSync(file.replace(/\*$/, ''));
                if (exist) {
                    return file;
                }
            }).filter(function (file) {
                return file !== undefined;
            }).join(' ');
        } catch (err) {
            //console.log(err);
        }
        try {
            var beforeCommand = Object.keys(defs).map(function (key) {
                if (commands[key]) {
                    if (commands[key].turn <= 1 && defs[key] == true) {
                        return commands[key].value;
                    } else {
                    }
                }
            }).filter(function (command) {
                return command !== undefined;
            }).join(' && ');
        }
        catch (err) {
            //console.log(err);
        }
        if (beforeCommand != '') {
            beforeCommand = beforeCommand + ' && ';
        }
        var afterCommand = Object.keys(defs).map(function (key) {
            if (commands[key]) {
                if (commands[key].turn > 1 && defs[key] == true) {
                    return commands[key].value;
                } else if (key == 'aggregateServer' && defs['aggregateServer'] == true) {
                    return 'systemctl restart ag_server';
                } else {
                    //return false;
                }
            }
        }).filter(function (command) {
            return command !== undefined;
        }).join(' && ');
        if (afterCommand != '') {
            afterCommand = '&& ' + afterCommand;
        }
        var comm = '#!/bin/sh\n' + beforeCommand + '/usr/bin/rsync -ap /tmp/confrestore/ / ' + afterCommand;
        fs.writeFileSync(__dirname + '/../backup/command.sh', comm);
        exec('cd ' + __dirname + '/../backup; tar -czf "./' + fileName + '.tar.gz" ' + strArgs + ' ./command.sh',
            function (error, stdout, stderr) {
                if (error !== null) {
                    console.log(error, stdout, stderr);
                    reject(Error("unable-to-zip"))
                } else {
                    resolve(fileName);
                }
            }
        )
    })
};
var confReboot = function (data) {
    return new Promise(function (resolve, reject) {
        var promises = Object.keys(data.data).map(function (item) {
            return new Promise(function (resolve, reject) {
                exec('chmod 700 /tmp/confrestore/backup/' + item + '.sh && /tmp/confrestore/backup/' + item + '.sh', function (error, stdout, stderr) {
                    if (error !== null) {
                        console.log(error, stdout, stderr)
                    } else {
                        resolve();
                    }
                })

            });
        });
        if (data.reboot) {
            Promise.all(promises).then(function () {
                //console.log('reboot');
                exec('/sbin/reboot');
            })
        } else {
            Promise.all(promises).then(function () {
                //console.log('reboot');
                resolve('confirm')
            })
        }
    });
};
module.exports={
    getBackUpDetails:getBackUpDetails,
    newBackup:newBackup,
    backup:backup,
    confReboot:confReboot
};