/**
 * Created by stts on 17.06.2016.
 */
var fs = require('fs'),
    exec = require('child_process').exec,
    rmdir = require('rimraf'),
    ftp = require('ftp'),
    http = require('http');
var getDisk=function(){
    return new Promise(function(resolve,reject){
        fs.readFile('/proc/mounts','utf8',function(err,data){
            var arr=data.split('\n');
            arr.pop();
            var excep=['cgroup','devpts','devtmpfs','sysfs','proc','tmpfs','debugfs','mqueue','configfs'];
            var res = arr.map(function(item){
                return item.split(' ');
            }).filter(function(item){
                if(!excep.includes(item[2])){
                    if(item[1]!='/'){
                        return item
                    }
                }
            });
            res = res.map(function(item){
                tmp= {
                    name:item[1].replace('/mnt/',''),
                    partition:item[2],
                    path:item[1],
                    realPath:item[0],
                };
                return tmp;
            });
            resolve(res);
        });

    });
};
var getFiles = function (path) {
    return new Promise(function (resolve, reject) {
        fs.exists(path,function(exist){
            if(exist){
                fs.readdir(path,function(err,files){
                    if(err){
                        reject(err)
                    }else{
                        var fileList = files.map(function (item) {
                            return new Promise(function(resolve,reject){
                                var file = {};
                                file.name = item;
                                var date;
                                // stats = fs.lstatSync(path + '/' + item);
                                fs.lstat(path+'/'+item,function(err,stats){
                                    if (stats.isFile()) {
                                        file.type = 'file';
                                    } else if (stats.isDirectory()) {
                                        file.type = 'dir'
                                    } else if (stats.isBlockDevice()) {
                                        file.type = 'blockDevice'
                                    } else if (stats.isCharacterDevice()) {
                                        file.type = 'characterDevice'
                                    } else if (stats.isSymbolicLink()) {
                                        file.type = 'symbolicLinc'
                                    } else if (stats.isFIFO()) {
                                        file.type = 'FIFO'
                                    } else if (stats.isSocket()) {
                                        file.type = 'socket'
                                    }
                                    if (file.type == 'dir') {
                                        file.size = '[ - ' + file.type + ' - ]';
                                    } else {
                                        file.size = (stats.size / 1024) / 1024;
                                        file.size = file.size.toFixed(2) + " MB";
                                    }
                                    date = new Date(stats.mtime);
                                    var customDate = function (date) {
                                        if (date < 10) {
                                            return '0' + date;
                                        } else {
                                            return date;
                                        }
                                    };
                                    file.modDate =
                                        date.getFullYear() + '-'
                                        + customDate(date.getMonth()) + '-'
                                        + customDate(date.getDate()) + ' '
                                        + customDate(date.getHours()) + ':'
                                        + customDate(date.getMinutes()) + ':'
                                        + customDate(date.getSeconds());


                                    resolve(file);
                                });
                            });

                        });
                        Promise.all(fileList).then(function(items){
                            var res = {
                                'file': items,
                                'path': path
                            };
                            resolve(res);
                        });

                    }
                });
            }else{
                reject();
            }
        });
    })
};
var createDir = function (data) {
    return new Promise(function (resolve, reject) {
        var dir = data.currPath + '/' + data.dirName;
        fs.mkdir(dir, function () {
            resolve(getFiles(data.currPath));
        });
    })
};
var shCommand = function (command) {
    return new Promise(function (resolve, reject) {
        //console.log(command);
        exec(command,
            function (err, stdout, stderr) {
                if (err !== null) {
                    reject(err);
                }
                resolve(stdout)
            });
    });
};
var renameFile = function (data) {
    return new Promise(function (resolve, reject) {
        var file = data.currPath + '/' + data.fileName;
        var oldPath = data.currPath + '/' + data.file.name;
        fs.rename(oldPath, file, function () {
            resolve(getFiles(data.currPath))
        })
    })
};
var deleteFile = function (data) {
    return new Promise(function (resolve, reject) {
        var file = data.currPath + '/' + data.fileName;
        fs.unlink(file, function (err) {
            resolve(getFiles(data.currPath));
        })
    })
};
var deleteDir = function (data) {
    return new Promise(function (resolve, reject) {
        var file = data.currPath + '/' + data.fileName;
        rmdir(file, function (err) {
            resolve(getFiles(data.currPath));
        })
    })
};
var moveFile = function (data) {
    return new Promise(function (resolve, reject) {
        pathArr = data.path.split('/');
        var path = data.beginPath;
        pathArr.forEach(function (segment) {
            path = path + '/' + segment;
            //console.log(path);
            var exist = fs.existsSync(path);

            if (!exist) {
                fs.mkdirSync(path);
            }
        });
        fs.exists(path, function (exist) {
            var file = path + '/' + data.file.name;
            var oldPath = data.currPath + '/' + data.file.name;
            if (exist) {
                //console.log('else here');
                fs.rename(oldPath, file, function () {
                    resolve(getFiles(data.currPath))
                })
            }
        });
    })
};
var downloadFrom = function (data,io) {
    return new Promise(function (resolve, reject) {

        /*dl = new Download.Download(data.url,data.currPath+'/upd_TPS3-agent.itb');
         dl.on('progress', function(progress) {
         console.log("" + progress + "%");
         });

         dl.on('end', function(code) {
         if (code === 0) {
         console.log("finished successfully");
         resolve(getFiles(data.currPath))
         } else {

         console.log("finished unsuccessfully");
         resolve(getFiles(data.currPath))
         }
         process.exit(code);
         });

         dl.start();*/
        var ftpObj = {};
        /*var regFile = /^ftp:\/\/.+\/(.*)/i;
         var regResFile = regFile.exec(data.url);
         var regUserPass=/^ftp:\/\/(.+:?.+@)?.+/i;
         var resUserPass=regUserPass.exec(data.url)[1].split(':');
         if(resUserPass.length>1){
         ftpObj.user=resUserPass[0];
         ftpObj.password=resUserPass[1].replace('@','');
         }else{
         ftpObj.user=resUserPass[0];
         }
         ftpObj.file = regResFile[1];*/
        //var regHost=/^ftp:\/\/(.+)\/.+/i;
        var segments = data.url.replace('ftp://', '').split('/');
        var hostData = segments[0];
        hostData = hostData.split('@');
        var auth;
        if (hostData.length > 1) {
            auth = hostData[0].split(':');
            if (auth.length > 1) {
                ftpObj.user = auth[0];
                ftpObj.password = auth[1];
            } else {
                ftpObj.user = auth;
            }
            ftpObj.host = hostData[1];
        } else {
            ftpObj.host = hostData;
        }
        segments.shift();
        var file = segments.join('/');
        var fileName=segments.pop();

        //console.log(file);
        //console.log(ftpObj);
        var client = ftp();
        client.on('ready', function () {
            client.get(file, function (err, stream) {
                stream.once('close', function () {
                    resolve(getFiles(data.currPath));
                    clearInterval(interval);
                    client.end();
                });
                var write = fs.createWriteStream(data.currPath + '/'+fileName);
                stream.pipe(write);
                var interval = setInterval(function(){
                    io.on('connection',function(socket){
                        socket.emit('filemanager:file:progress',write.bytesWritten);
                    });

                    //resolve({then:function(onFulfill, onReject){ onFulfill(write.bytesWritten)}} );
                },1000)
            })
        });
        client.connect(ftpObj);

    });

};
var copyFile = function (data) {
    return new Promise(function (resolve, reject) {
        //fs.createReadStream(data.currPath+'/'+data.file.fileName).pipe(fs.createWriteStream(data.path));
        resolve()
    });
};
var formatDisk=function(data){
    return new Promise(function(resolve,reject){
        // console.log
        exec('umount '+data.dist+';mkfs.'+data.format+' '+data.dist+'; mount '+data.dist,function(err,stdout,stderr){
            if(err){
                console.log(err,stdout);
            }
            else{
                resolve('okay')
            }
        })
    });
};
var unmountDisk=function(data){
    return new Promise(function(resolve,reject){
        exec('umount '+data,function(err,stdout,stderr){
            if(err){
                console.log(err,stderr);
            }else{
                resolve()
            }

        })
    });
};
module.exports = {
    getFiles: getFiles,
    shCommand: shCommand,
    createDir: createDir,
    renameFile: renameFile,
    deleteFile: deleteFile,
    deleteDir: deleteDir,
    moveFile: moveFile,
    downloadFrom: downloadFrom,
    copyFile: copyFile,
    getDisk:getDisk,
    formatDisk:formatDisk,
    unmountDisk:unmountDisk
};