var exec = require('child_process').exec;
var ini = require("ini");
var shellescape = require("shell-escape");
var async = require('async');

exports.printEnv = function(){
    return new Promise(function(resolve,reject){
        exec('fw_printenv',
            function (error, stdout, stderr) {
                if(error !== null){
                    //socket.emit("firmware:error",{code:"unable-to-get"});
                    reject(Error("unable-to-get"))
                }else{
                    var output = ini.parse(stdout);
                    var data = {
                        serverip:output.serverip,
                        updatefile:output['tps_upd_f'],
                        protocol:output['tps_upd_p'],
                        ethaddr:output['ethaddr'],
                        tpsUpdOnBoot:output['tps_upd_onboot'],

                    };
                    resolve(data);
                    //socket.emit("firmware:printenvComplete",data);
                }
            }
        )
    })
};

exports.setEnv = function(data){
    var setVariable = function(key,value,callback){
        var command;

        if (value == undefined || value == "" || value == null){
            command = shellescape(['fw_setenv',key]);
        }else{
            command = shellescape(['fw_setenv',key,value]);
        }
        exec(command,
            function (error, stdout, stderr) {
                callback(error);
            }
        )
    };

    return new Promise(function(resolve,reject){
        if(data.mode == "off"){
            data.serverip = null;
            data.updatefile = null;
            data.protocol = null;
        }

        async.parallel([
                function(callback){
                    setVariable("serverip",data.serverip,callback);
                },
                function(callback){
                    setVariable("tps_upd_f",data.updatefile,callback);
                },
                function(callback){
                    setVariable("tps_upd_p",data.protocol,callback);
                },
                function(callback){
                    setVariable("tps_upd_onboot",data.tpsUpdOnBoot,callback);
                }
            ],
            function(err, results){
                if(err !== null){
                    //console.log(err);
                    reject(Error("unable-to-set"));
                    //socket.emit("firmware:error",{code:"unable-to-set"});
                }else{
                    resolve();
                    //socket.emit("firmware:setenvComplete");
                    //printEnv(socket);
                }
            });
    });
};