/**
 * Created by stts on 04.05.2016.
 */
var fs = require('fs');
var os = require('os');
var exec = require('child_process').exec;
var _ = require('underscore');
let serviceName='gprs3g';
var advanced = false;
//var execSync = require('child_process').execSync;
var status = function () {
    return new Promise(function (resolve, reject) {
        var data = {};
        var profiles;
        getProfiles().then(function (v) {
            profiles = v;

            var networkInterfaces = os.networkInterfaces();

            var getIp = function (file) {
                return new Promise(function (resolve, reject) {
                    var networkInterfaces = os.networkInterfaces();
                    profile(file).then(function (prof) {
                        if (networkInterfaces['ppp' + prof.unit]) {
                            resolve({"ip": networkInterfaces['ppp' + prof.unit][0].address, 'socket': prof.mSocket});
                        } else {
                            resolve({"ip": 'not connected', "socket": prof.mSocket});
                        }
                    });

                });
            };
            var isAutoload = function (file) {
                return new Promise(function (resolve, reject) {
                    exec('/bin/systemctl is-enabled '+serviceName+'@' + file,
                        function (error, stdout, stderr) {
                            var re = /^enabled/i;
                            if (re.test(stdout)) {
                                resolve('enabled');

                            }
                            else {
                                resolve('disabled');

                            }
                        }
                    );
                });
            };
            var isActive = function (file) {
                return new Promise(function (resolve, reject) {
                    // console.log(file);
                    exec('/bin/systemctl is-active '+serviceName+'@' + file,
                        function (error, stdout, stderr) {

                            var re = /^active/i;
                            if (re.test(stdout)) {
                                resolve('active');
                            }
                            else {
                                resolve('inactive');
                            }
                        }
                    );
                });
            };
            let getSignal=(file)=>{
                return new Promise((resolve,reject)=>{
                    let sock = {
                        'O0': 'S19',
                        'O1': 'S3',
                        'O3': 'S7',
                        'O4': 'S15',
                        'O5': 'S11',
                        'USB0':'USB0',
                        'USB1':'USB1',
                        'USB2':'USB2',
                        'USB3':'USB3',
                        'USB4':'USB4',
                        'USB5':'USB5'


                    };
                    // console.log(file);
                    // console.log('/tmp/'+sock[file.toUpperCase()]+"_sigs");
                    fs.access('/tmp/'+sock[file.toUpperCase()]+"_sigs", fs.constants.R_OK, (err) => {
                        // console.log(err ? 'no access!' : 'can read');
                        if(!err){
                            fs.readFile('/tmp/'+sock[file.toUpperCase()]+"_sigs",'utf8',(err,data)=>{
                                let signal=data.split(',');
                                let res='';
                                switch (!!signal[0]){
                                    case (signal[0]<10):
                                        res='very bad';
                                        break;
                                    case (signal[0]>=10&&signal[0]<15):
                                        res='so-so';
                                        break;
                                    case (signal[0]>=15&&signal[0]<20):
                                            res="good";
                                            break;
                                    case (signal[0]>20):
                                        res="excellent";
                                        break;
                                }
                                resolve(res);

                            })
                        }else{resolve()}

                    });
                })
            };
            profiles.forEach(function (file) {
                let name = file.replace('tty','');
                // console.log('gprs profiles',name);
                Promise.all([isAutoload(name), isActive(name), getIp(file),getSignal(name)]).then(function (res) {
                    data[file] = {'active': res[1], 'autoload': res[0], 'ip': res[2].ip, 'socket': res[2].socket,'signal':res[3]};
                    if (Object.keys(data).length == profiles.length) {
                        resolve(data);
                    }
                });
            });
        });


    });

};
var statusCurrent = function () {
};
var getProfiles = function () {
    return new Promise(function (resolve, reject) {
        exist = fs.existsSync('/etc/ppp/peers');
        if (exist) {
            var files = fs.readdirSync('/etc/ppp/peers');
            var data = files.map(function (file) {
                return file
            }).filter(function (item) {
                regExp = /^tty.*/;
                return regExp.test(item);
            });
            resolve(data);
        } else {
            reject(false);
        }
    });
};
var profile = function (name) {
    return new Promise(function (resolve, reject) {
        exist = fs.existsSync('/etc/ppp/peers/' + name);
        if (exist) {
            var arr = {
                'mSocket': '',
                'chatScriptName': '',
                'auth': '',
                'user': '',
                'pass': '',
                'debugEnabled': false,
                'chatScript': '',
                'unit': ''
            };
            var sock = {
                'O0': 's17',
                'O1': 's1',
                'O3': 's5',
                'O4': 's13',
                'O5': 's9',
                'USB0':'USB0',
                'USB1':'USB1',
                'USB2':'USB2',
                'USB3':'USB3',
                'USB4':'USB4',
                'USB5':'USB5'

            };
            var profile = fs.readFileSync('/etc/ppp/peers/' + name);
            var lines = profile.toString().split(/\n/);
            // var comandRegexp = /.+T_reset.sh\s([^\s]+)\s.+\/dev\/tty([^\s]+)\s.+\/([^\s]+).*/i;
            let ttyRegexp=/^\/dev\/tty(.+)/i;
            lines.forEach(function (line) {
                if (/^\/dev.+/i.test(line)) {
                    let res=ttyRegexp.exec(line);
                    arr.mSocket = sock[res[1]];
                }
                arr.chatScriptName = name;
                if (/^user.+/i.test(line)) {
                    username = /^user\s([^\s]+)/.exec(line);
                    arr.user = username[1];
                    arr.auth = true;
                }
                if (/^debug/i.test(line)) {
                    arr.debugEnabled = true;
                }
                if (/^unit\s\d{1,2}/i.test(line)) {
                    var unit = /^unit\s(\d{1,})/i.exec(line);
                    arr.unit = unit[1];
                }
            });
            if (arr.auth) {
                var papExist = fs.existsSync('/etc/ppp/pap-secrets');
                var chapExist = fs.existsSync('/etc/ppp/chap-secrets');
                var regStr = '^' + arr.user + '\\s+[^\\s]\\s+([^\\s]+)';
                var reg = new RegExp(regStr, 'im');
                if (papExist) {
                    var pap = fs.readFileSync('/etc/ppp/pap-secrets', 'utf8');
                    if (reg.test(pap)) {
                        pass = reg.exec(pap);
                        arr.pass = pass[1];
                    }

                }
                else if (chapExist) {
                    var chap = fs.readFileSync('/etc/ppp/chap-secrets');
                    pass = reg.exec(chap.toString());
                    arr.pass = pass[1];
                }
            }
            if (arr.chatScriptName) {
                var chatScriptExist = fs.existsSync('/etc/chatscripts/' + arr.chatScriptName + '.chat');
                if (chatScriptExist) {
                    var chatScript = fs.readFileSync('/etc/chatscripts/' + arr.chatScriptName + '.chat', 'utf8');
                    var regChatScript = /^OK\s\sATE[0-1]+\n^OK.+\n^OK.+\n/m;
                    if (regChatScript.test(chatScript)) {
                        var opt = regChatScript.exec(chatScript);
                        arr.chatScript = opt[0];
                    }
                }
            }
            resolve(arr);
        } else {
            reject(false);
        }
    });

};
var save = function (data) {
    return new Promise(function (resolve, reject) {
        ttyArr = {
            's17': 'O0',
            's1': 'O1',
            's5': 'O3',
            's13': 'O4',
            's9': 'O5',
            'USB0':'USB0',
            'USB1':'USB1',
            'USB2':'USB2',
            'USB3':'USB3',
            'USB4':'USB4',
            'USB5':'USB5'
        };
        let ttyUsbReg=/usb/i;
        let usb;
        let gprsTmplPath;
        if (ttyUsbReg.test(data.mSocket)){
            usb=true;
            gprsTmplPath ='/opt/tps-shared/gprs-tpl/usb3g.template';
        }else{
            usb=false;
            gprsTmplPath='/opt/tps-shared/gprs-tpl/gprs.template';
        }
        var templateProfileExist = fs.existsSync(gprsTmplPath);
        if (templateProfileExist) {
            var templateProfile = fs.readFileSync(gprsTmplPath, 'utf8');
            var templateChatScript = fs.readFileSync('/opt/tps-shared/gprs-tpl/chat.template', 'utf8');
            var gpiReg = /\{t\.gpi\}/img;
            var ttyReg = /\{t\.tty\}/img;
            var profileReg = /\{t\.profile\}/img;
            var userReg = /\{t.user\}\n/i;
            var debugReg = /\{t\.debug\}/img;
            var chatReg = /\{t\.chat\}/img;
            var unitReg = /\{t\.unit\}/img;
            if(data.mSocket!=undefined){
                data.mSocket=_.invert(ttyArr)[data.filename.split('tty')[1]];
            }
            //console.log(data.mSocket,_.invert(ttyArr)[data.filename.split('tty')[1]]);
            var gpi = data.mSocket[0] + (parseInt(data.mSocket.replace(/^s/, '')) + 2);
            if (data.chatScript) {

            }
            templateChatScript = templateChatScript.replace(chatReg, data.chatScript);
            // console.log(templateChatScript);
            templateProfile = templateProfile.replace(gpiReg, gpi.toUpperCase());
            if(usb){
                templateProfile = templateProfile.replace(ttyReg, 'tty' + data.mSocket);
            }else{
                templateProfile = templateProfile.replace(ttyReg, 'tty' + ttyArr[data.mSocket]);
            }
            templateProfile = templateProfile.replace(profileReg, data.chatScriptName);
            templateProfile = templateProfile.replace(unitReg, 'unit ' + data.unit);
            if (data.user) {
                templateProfile = templateProfile.replace(userReg, 'user ' + data.user + '\n');
            } else {
                templateProfile = templateProfile.replace(userReg, '');
            }

            if (data.debugEnabled == true) {
                templateProfile = templateProfile.replace(debugReg, 'debug\nkdebug 10');
            } else {
                templateProfile = templateProfile.replace(debugReg, '');
            }
            fs.writeFileSync('/etc/ppp/peers/' + data.filename, templateProfile);

            fs.writeFileSync('/etc/chatscripts/' + data.filename + '.chat', templateChatScript);
            if (data.filename != 'new' && data.filename != data.chatScriptName) {
                fs.renameSync('/etc/ppp/peers/' + data.filename, '/etc/ppp/peers/' + data.chatScriptName);
                fs.renameSync('/etc/chatscripts/' + data.filename + '.chat', '/etc/chatscripts/' + data.chatScriptName + '.chat')
            }
            if (data.user) {
                var papExist = fs.existsSync('/etc/ppp/pap-secrets');
                var chapExist = fs.existsSync('/etc/ppp/chap-secrets');
                var regStr = '^' + data.user + '\\s+[^\\s]\\s+([^\\s]+)';
                var reg = new RegExp(regStr, 'im');
                if (papExist) {
                    var pap = fs.readFileSync('/etc/ppp/pap-secrets', 'utf8');
                    if (reg.test(pap)) {
                        pap = pap.replace(reg, data.user + '\t*\t' + data.pass);
                        fs.writeFileSync('/etc/ppp/pap-secrets', pap);
                    } else {
                        fs.appendFileSync('/etc/ppp/pap-secrets', '\n' + data.user + '\t*\t' + data.pass)
                    }
                }
                if (chapExist) {
                    var chap = fs.readFileSync('/etc/ppp/chap-secrets', 'utf8');
                    if (reg.test(chap)) {
                        chap = chap.replace(reg, data.user + '\t*\t' + data.pass);
                        fs.writeFileSync('/etc/ppp/chap-secrets', chap);
                    }
                    else {
                        fs.appendFileSync('/etc/ppp/chap-secrets', '\n' + data.user + '\t*\t' + data.pass)
                    }
                }
            }
            // console.log('resolving');
            resolve();
        }
    });


};
var del = function (profile) {
    return new Promise(function (resolve, reject) {
        var profileExist = fs.existsSync('/etc/ppp/peers/' + profile);
        var chatExist = fs.existsSync('/etc/chatscripts/' + profile + '.chat');
        if (profileExist) {
            fs.unlinkSync('/etc/ppp/peers/' + profile);
        }
        if (chatExist) {
            fs.unlinkSync('/etc/chatscripts/' + profile + '.chat');
        }
        resolve();
    });
};
var togleCommand = function (arr) {
    return new Promise(function (resolve, reject) {
        let name= arr[0].replace('tty','');
        // console.log('/bin/systemctl ' + arr[1] + ' '+serviceName+'@' + name);
        exec('/bin/systemctl ' + arr[1] + ' '+serviceName+'@' + name,
            function (error, stdout, stderr) {
                if(error!==null&&stderr!==''){
                    console.log(error + '|', stdout + '|', stderr);
                }

                resolve()
            }
        );
    });

};
let scanTty=()=>{
    return new Promise((resolve,reject)=>{
        return getProfiles().then((profiles)=>{
            console.time('test');
            fs.readdir('/dev',(err,files)=>{
                let res=files.filter((item)=>{
                    return !profiles.includes(item)&&checkAvailableTty(item)
                });
                console.timeEnd('test');
                resolve(res);
            });
        });

        // resolve();
    })
};
let checkAvailableTty=(data)=>{

    if(/ttyO\d/.test(data)){
        return true;
    }
    else if(/ttyUSB\d/.test(data)){
        return true;
    }
    else{
        return false;
    }


};
let searchUsb=()=>{
    return new Promise((resolve,reject)=>{
        fs.readdir('/dev',(err,files)=>{
            // console.log(files);
            let reg = /usb/i;
            let res = files.map((file)=>{
                return file.split('tty')[1];
            }).filter((item)=>{
                return reg.test(item);
            });
            if(res.length>0){
                resolve(res);
            }else{
                reject();
            }
        });
    });
};
module.exports = {
    togleCommand: togleCommand,
    delete: del,
    save: save,
    profile: profile,
    getProfiles: getProfiles,
    statusCurrent: statusCurrent,
    status: status,
    searchUsb:searchUsb,
    scanTty:scanTty
};