var spawn = require('child_process').spawn;

var logProcess;

var killLogProcess = function(){
    if(typeof logProcess !== 'undefined') {
        try {
            logProcess.kill();
        } catch (error) {
            console.log("Unable to terminate journalctl: "+error)
        }
    }
};

exports.killLogProcess = killLogProcess;
exports.getLog = function(socket,data){
    killLogProcess();

    var execKeys = ["-o", "json","-l","-n", "1000","--no-pager"];

    Object.keys(data).forEach(function(key){
        var value = data[key];
        if(value !== undefined){
            if(key == "since"){
                execKeys = execKeys.concat(["--since="+value]);
            }
            else if(key == "until"){
                execKeys = execKeys.concat(["--until="+value]);
            }
            else if(key == "unit"){
                execKeys = execKeys.concat(["--unit="+value]);
            }
            else if(key == "priority"){
                var possibleValues = ["emerg","alert","crit","err","warning","notice","info","debug"];
                execKeys = execKeys.concat(["-p",possibleValues[value]]);
            }
            else if(key == "follow" && value == "on"){
                execKeys = execKeys.concat(["-f"]);
            }
        }
    });

    logProcess = spawn('/bin/journalctl', execKeys)
        .on("error",function(){
            socket.emit("log:error",{code:"unable-to-get"});
        });

    logProcess.stdout.on('data', function (data) {
        socket.emit("log:getCompleteFollow",String(data));
    });

    logProcess.on('close',function(code){
        //console.log("closed width code")
        if(code != 0 && code != null){
            //console.log("code: "+code);
            socket.emit("log:error",{code:"unable-to-get",id:code});
        }
    });
};

