var exec = require('child_process').exec;
var fs = require('fs');
var async = require('async');
var ini= require('ini');

exports.reboot = function(){
    exec('/sbin/reboot')
};

exports.buzz = function(){
    var timer = 5000;
    var freq = 440;

    function beep(value,callback){
        exec('/opt/tps-beeper/beep_tone '+value,
            function (error, stdout, stderr) {
                callback(error);
            }
        );
    }

    function blink(value,callback){
        fs.writeFile("/proc/tpsleds/0",value,
            function(error){
                callback(error);
            }
        );
    }

    return new Promise(function(resolve,reject){
        async.parallel(
            [
                function(callback){
                    beep(freq,callback);
                },
                function(callback){
                    blink(1,callback);
                }
            ],
            function(err){
                if(err !== null){
                    reject (Error("unable-to-buzz"));
                }else{
                    setTimeout(function(){
                        async.parallel(
                            [
                                function(callback){
                                    beep(0,callback);
                                },
                                function(callback){
                                    blink(0,callback);
                                }
                            ],
                            function(err){
                                if(err !== null){
                                    reject (Error("unable-to-buzz"));
                                }else{
                                    resolve();
                                }
                            });
                    },timer);
                }
            }
        );
    })
};

exports.restartWebServer = function(){
    process.exit(10);
};
exports.changeFirstSerial= function(val){
    let map={
        'enable':'restart',
        'disable':'stop'
    }
    console.log('fw_setenv console '+val.env)
    exec('fw_setenv console '+val.env,function (error, stdout, stderr) {
        if(error!==null && stderr!==''){
            console.log(error,stdout,stderr)
        }
        else{
            exec('systemctl '+map[val.serial]+' serial-getty@ttyO0 && /bin/systemctl '+val.serial+' serial-getty@ttyO0',function(error,stdout,stderr){
                if(error!==null && stderr!==''){
                    console.log(error,stdout,stderr)
                }
            })
            /*exec('systemctl '+map[val.serial]+' serial-getty@ttyO0',function(error,stdout,stderr){
                if(error!==null && stderr!==''){
                    console.log(error,stdout,stderr)
                }
            })*/
        }
    })
};
exports.envConsole=function(){
    return new Promise(function(resolve,reject){
        exec('fw_printenv console',function(error,stdout,stderr){
            var res=ini.parse(stdout,'utf8');
            resolve(res.console);
        });
    });
};
exports.regenerateSshKey=function(){
    return new Promise(function(resolve,reject){
        fs.readdir('/etc/ssh/',function(err,files){
            if(err!==null){
                reject()
            }
            else{
                files.forEach(function(file){
                    if(/^ssh_host_.*/i.test(file)){
                        fs.unlink('/etc/ssh/'+file,function(err){
                            if(err!==null){
                                console.log(err)
                            }
                            else{
                                resolve('iha')
                            }
                        })
                    }
                })
            }
        })


    });
};
var replaceCert = (files)=>{
    return new Promise((resolve,reject)=>{
        exec('mkdir /tmp/tpswanUploads/ssl -p',(err,stdout,stderr)=>{
            if(err!==null&&stderr!=='')console.log(err,stderr);
            var pr1=()=>{
                return new Promise((resolve,reject)=>{
                    fs.access('/etc/nginx/ssl/all.crt',(err)=>{
                        if(err!==null){
                            console.log(err);
                            resolve(false)
                        }
                        resolve(true)
                    })
                })
            };
            var pr2=()=>{
                return new Promise((resolve,reject)=>{
                    fs.access('/etc/nginx/ssl/all.key',(err)=>{
                        if(err!==null){
                            console.log(err);
                            resolve(false)
                        }
                        resolve(true)
                    })
                })
            };
            Promise.all([pr1(),pr2()]).then((res)=>{
                if(res[0]===true&&res[1]===true){
                    exec('mv /etc/nginx/ssl/all.crt /tmp/tpswanUploads/ssl/all.crt -f;' +
                        'mv /etc/nginx/ssl/all.key /tmp/tpswanUploads/ssl/all.key -f',(err,stdout,stderr)=>{
                        if(err!==null && stderr!==''){
                            console.log(err,stdout,stderr);
                            reject(err,stderr);
                        }else{
                            exec('mv /tmp/tpswanUploads/' + files[0] + ' /etc/nginx/ssl/all.crt -f;' +
                                'mv /tmp/tpswanUploads/' + files[1] + ' /etc/nginx/ssl/all.key -f',(err,stdout,stderr)=>{
                                if(err!==null && stderr!==''){
                                    console.log(err,stdout,stderr);
                                    reject(err,stderr);
                                }else{
                                    exec('nginx -t',(err,stdout,stderr)=>{
                                        if(err!==null&&stderr!==''){
                                            reject(err,stderr);
                                        }else{
                                            resolve()
                                        }
                                    })
                                }
                            });
                        }
                    })
                }else{
                    exec('mv /tmp/tpswanUploads/' + files[0] + ' /etc/nginx/ssl/all.crt -f;' +
                        'mv /tmp/tpswanUploads/' + files[1] + ' /etc/nginx/ssl/all.key -f',(err,stdout,stderr)=>{
                        if(err!==null && stderr!==''){
                            console.log(err,stdout,stderr);
                            reject(err,stderr);
                        }else{
                            exec('nginx -t',(err,stdout,stderr)=>{
                                if(err!==null&&stderr!==''){
                                    exec('mv /tmp/tpswanUploads/all.crt /etc/nginx/ssl/all.crt -f;' +
                                        'mv /tmp/tpswanUploads/all.key /etc/nginx/ssl/all.key -f;',
                                        (err,stdout,stderr)=>{
                                            if(err!==null&&stderr!=='')console.log(err,stderr);
                                            resolve()
                                        });
                                    // reject(err,stderr);
                                }else{
                                    resolve()
                                }
                            })
                        }
                    });
                }
            });

        });
    });
};
exports.checkSslSum=function (files) {
    return new Promise(function(resolve,reject){
        // console.log('проверили бля сумму');
        // console.log(files);
        var pr1=()=>{
            return new Promise((resolve,reject)=>{
                exec('openssl x509 -noout -modulus -in /tmp/tpswanUploads/'+files[0],(err,stdout,stderr)=>{

                // exec('ssl x509 -noout -modulus -in /tmp/tpswanUploads/'+files[0]+'| openssl md5',(err,stdout,stderr)=>{
                    if(err!==null && stderr!==''){
                        console.log(err,stdout,stderr)
                    }else{
                        resolve(true);
                    }
                });
            })
        };
        var pr2=()=>{
            return new Promise((resolve,reject)=>{
                exec('openssl rsa -noout -modulus -in /tmp/tpswanUploads/'+files[1],(err,stdout,stderr)=>{
                // exec('openssl rsa -noout -modulus -in /tmp/tpswanUploads/'+files[1]+'| openssl md5',(err,stdout,stderr)=>{
                    if(err!==null && stderr!==''){
                        console.log(err,stdout,stderr)
                    }else{
                        resolve(true);
                    }
                });
            })
        };
        var pr3=()=>{
            return new Promise((resolve,reject)=>{
                exec('openssl x509 -noout -modulus -in /tmp/tpswanUploads/'+files[0]+'| openssl md5',(err,stdout,stderr)=>{
                    if(err!==null && stderr!==''){
                        console.log(err,stdout,stderr)
                    }else{
                        resolve(stdout);
                    }
                });
            })
        };
        var pr4=()=>{
            return new Promise((resolve,reject)=>{
                exec('openssl rsa -noout -modulus -in /tmp/tpswanUploads/'+files[1]+'| openssl md5',(err,stdout,stderr)=>{
                    if(err!==null && stderr!==''){
                        console.log(err,stdout,stderr)
                    }else{
                        resolve(stdout);
                    }
                });
            })
        };
        Promise.all([pr1(),pr2()]).then((items)=>{
            if (items[0]&&items[1]){
                console.log('good');
                Promise.all([pr3(),pr4()]).then((res)=>{
                    if(res[0]===res[1]){
                        console.log('good2');
                        replaceCert(files).then((res)=>{
                            console.log('good3');
                            exec('systemctl reload nginx',(err,stdout,stderr)=>{
                                if(err!==null&stderr!==''){
                                    console.log(err,stderr);
                                }else{
                                    resolve()
                                }
                            })
                        });
                    }
                });
            }
        });

    })
};
var reloadNginx=(cb)=>{
    let callback=cb!==undefined ? cb : ()=>{};
    exec('systemctl restart nginx',callback)
};
exports.statusPort=()=>{
    return new Promise((resolve,reject)=>{
        fs.access('/var/www/tps-wan/conf/port_80.conf',(err)=>{
            if(err!==null){
                // console.log(err);
                resolve(false)
            }
            resolve(true)
        })
    });

};
exports.actionPort=(action)=>{
    return new Promise((resolve,reject)=>{
        switch(action){
            case 'enable':
                exec('mv /var/www/tps-wan/conf/port_80.conf.disabled ' +
                    '/var/www/tps-wan/conf/port_80.conf',
                    (err,stdout,stderr)=>{
                        if(err!==null&&stderr!==''){}/*console.log(err,stderr);*/
                        else{
                            reloadNginx((err,stdout,stderr)=>{
                                if(err!==null&&stderr!==''){}/*console.log(err,stderr);*/
                                // console.log('work helper function');
                                resolve(true);
                            });
                        }
                    });
                break;

            case 'disable':
                // resolve(false);
                exec('mv /var/www/tps-wan/conf/port_80.conf ' +
                    '/var/www/tps-wan/conf/port_80.conf.disabled',
                    (err,stdout,stderr)=>{
                        if(err!==null&&stderr!==''){}/*console.log(err,stderr);*/
                        else{
                            reloadNginx((err,stdout,stderr)=>{
                                if(err!==null&&stderr!==''){}/*console.log(err,stderr);*/
                                // console.log('work helper function');
                                resolve(false);
                            });
                        }
                    });
                break;

        }
    })
};
/*
module.exports={
    regenerateSshKey:regenerateSshKey
};*/
