const spawn = require('child_process').spawn;
const exec = require('child_process').exec;
const ini = require("ini");
const fs = require('fs');
var updateLogProcess;
// var rpmsbase= process.env['RPMSBASE'];
var rpmsbase = 'http://tibbo.com/downloads/LTPS/packets/';
//var PythonShell = require('python-shell');
var rpmList;
function escape(arg) {
    if (!/^[A-Za-z0-9_\/-]+$/.test(arg)) {
        arg = "'" + arg.replace(/'/g, "'\\''") + "'";
        arg = arg.replace(/^(?:'')+/g, '') // unduplicate single-quote at the beginning
            .replace(/\\'''/g, "\\'"); // remove non-escaped single-quote if there are enclosed between 2 escaped
    }
    return arg;
}
var installTibboChannel = function () {
    return new Promise(function (resolve, reject) {


        var command = 'smart channel --add a0 type=rpm-md name="Tibbo LTPS all" baseurl=' + rpmsbase + '/all/ -y;' +
            'smart channel --add a1 type=rpm-md name="Tibbo LTPS general" baseurl=' + rpmsbase + '/cortexa8hf_neon/ -y;' +
            'smart channel --add a2 type=rpm-md name="Tibbo LTPS tpp" baseurl=' + rpmsbase + '/tpp/ -y';
        console.log(command);
        exec(command, function (err, stdout, stderr) {
            if (err !== null || stderr !== "") {
                console.log(err)
            } else {
                console.log('tibbo installed success!');
                resolve()
            }
        })
    });
};
var addChannel = function (data) {
    console.log(data);

    return new Promise(function (resolve, reject) {
        // var command = "smart channel --add " + escape(data.name) + " type=rpm-md name=" + escape(data.desc) + " baseurl=" + escape(data.url) + " --yes";
        //var command = 'smart channel --add 150c type=rpm-md name="150crepo" baseurl=http://192.168.75.150/cortexa8hf_neon/ --yes';
        // let writeConf =fs.createWriteStream('/etc/yum.repos.d/'+data.name+'.repo')
        let fileText = "[" + data.name + "]\n" +
            "name=" + data.desc + "\n" +
            "baseurl=" + data.url + "";

        fs.writeFile('/etc/yum.repos.d/' + data.name + '.repo', fileText, ['utf-8'], (err) => {
            if (err) {
                reject(Error(err));
            }
            resolve()
        })
        //console.log(command);

        /*exec(command,function(err,stdout,stderr){
         // console.log("err"+err,"stdout"+stdout,"stderr"+stderr);
         if(err !== null || stderr !== ""){
         reject(Error(stderr));
         }else{
         // console.log(stdout);
         resolve();
         }
         });*/
    })
};

var removeChannel = function (name) {
    return new Promise(function (resolve, reject) {
        if(name.length>0){
            fs.unlink('/etc/yum.repos.d/'+name+'.repo',(err)=>{
                console.log(err);
                if(err){

                    // reject(Error("unable-to-remove"));
                }else{
                    resolve()
                }
            });
        }
        /*if (id != "rpmsys") {
            // var command = "/var/www/tps-wan/conf/child_ul.sh smart channel --remove "+escape(id)+" --yes";
            var command = "smart channel --remove " + escape(id) + " --yes";

            //console.log(command);

            exec(command, function (err, stdout, stderr) {
                console.log("err" + err, "stdout" + stdout, "stderr" + stderr);
                if (err !== null || stderr !== "") {
                    reject(Error("unable-to-remove"));
                } else {
                    resolve();
                }
            });
        } else {
            reject(Error("locked-channel"));
        }*/
    })
};

var listChannels = function () {
    return new Promise(function (resolve, reject) {
        // var command = "/var/www/tps-wan/conf/child_ul.sh smart channel --show";
        // var command = "smart channel --show";
        var command = "dnf -v --all repolist";
        exec(command, function (err, stdout, stderr) {
            if (err !== null /*|| stderr !== ""*/) {
                console.log(err,stderr);
                reject(Error("unable-to-list"));
            } else {
                let splitRes= stdout.split('\n\n').slice(1);
                // splitRes= stdout.split('\n\n').slice(-1);
                // let regexp=
                let repoInfo = splitRes.map((item)=>{
                    let objectRes={};
                    item.split('\n').forEach((row)=>{
                        if(row.length>0){
                            let tmp=row.split(/(^.+?):(.+?$)/);
                            objectRes[tmp[1].trim()]=tmp[2].trim();
                        }

                    });
                    return {objectRes}
                }).filter((item)=>{
                    return item;
                });
                resolve({list:repoInfo,block:true});
                // console.log(repoInfo);
                /*try {
                    var block = false;
                    var list = ini.parse(stdout);
                    var reg = new RegExp('^' + rpmsbase, 'i');
                    // console.log(list);
                    Object.keys(list).some(function (item) {
                        // console.log(list[item].baseurl);
                        if (reg.test(list[item].baseurl)) {
                            block = true;
                            return true
                        }
                    });
                    /!*list.some(function(item){
                     if (reg.test(item.baseurl)){
                     block=true;
                     return true
                     }
                     });*!/

                    // resolve(list);
                    resolve({list, block});
                } catch (e) {
                    reject(Error("unable-to-parse"));
                }*/
            }
        });
    })
};
/*var search = function (data) {
    return new Promise((resolve, reject) => {
        var installedPack = () => {
            return new Promise((resolve, reject) => {
                /!* var arr=[];
                 var commandProcess=spawn('/var/www/tps-wan/conf/child_ul.sh',['smart','query','--installed','--hide-version','\*'+data+'\*']).on('error',()=>{
                 // console.log('err command')
                 });
                 commandProcess.stdout.on('data',(data)=>{
                 arr.push(data);
                 // socket.emit('packets:getLog',{timestamp:Date(),data:String(data)});
                 });
                 commandProcess.stderr.on('data',(err)=>{
                 console.log(err.toString());
                 });
                 commandProcess.on('close',(code)=>{
                 // console.log("end logging");
                 if(code != 0 && code != null){
                 console.log("code: "+code);
                 // socket.emit("log:error",{code:"unable-to-get",id:code});

                 }else{
                 arr.splice(0,3);
                 arr.splice(-3,3);
                 resolve(arr);
                 // resolve();
                 }
                 });*!/
                // exec('/var/www/tps-wan/conf/child_ul.sh smart query --installed --hide-version \*'+data+'\*',{cwd:'/var/www/tps-wan/empty'},(err,stdout,stderr)=>{
                /!*exec('smart query --installed --hide-version "*' + data + '*"', (err, stdout, stderr) => {
                    // exec('/var/www/tps-wan/conf/x.sh '+data,(err,stdout,stderr)=>{
                    if (err) {
                        console.log(err);
                    } else {
                        var arr = stdout.split('\n');
                        arr.splice(0, 3);
                        arr.splice(-3, 3);
                        resolve(arr);
                    }
                })*!/
                exec('rpm -qa | sort | grep ".'+data+'."',(err,stdout,stderr)=>{
                    if(err){
                        console.log(err);
                        throw new error('')
                    }
                })
            })
        };
        var smartSearch = () => {
            return new Promise((resolve, reject) => {
                /!*var arr=[];
                 var commandProcess=spawn('/var/www/tps-wan/conf/child_ul.sh',['smart','search','\*'+data+'\*']).on('error',()=>{
                 // console.log('err command')
                 });
                 commandProcess.stdout.on('data',(data)=>{
                 arr.push(data);
                 // socket.emit('packets:getLog',{timestamp:Date(),data:String(data)});
                 });
                 commandProcess.stderr.on('data',(err)=>{
                 console.log(err.toString());
                 });
                 commandProcess.on('close',(code)=>{
                 // console.log("end logging");
                 if(code != 0 && code != null){
                 console.log("code: "+code);
                 // socket.emit("log:error",{code:"unable-to-get",id:code});

                 }else{
                 arr.splice(0,3);
                 arr.splice(-3,3);
                 resolve(arr);
                 // resolve();
                 }
                 });*!/
                // exec(`/var/www/tps-wan/conf/child_ul.sh smart search '\*`+data+`\*'`,(err,stdout,stderr)=>{
                exec('smart search "*' + data + '*"', (err, stdout, stderr) => {
                    var arr = stdout.split('\n');
                    arr.splice(0, 3);
                    arr.splice(-3, 3);
                    resolve(arr);
                })
            })
        };
        Promise.all([installedPack(), smartSearch()]).then((items) => {
            console.log(items);
            var res = items[1].map((item) => {
                if (item.length > 0) {
                    var tmpRes = /(.+?)\s-\s(.+)/g.exec(item);
                    if (items[0].includes(tmpRes[1])) {
                        return {name: tmpRes[1], desc: tmpRes[2], install: true}
                    } else {
                        return {name: tmpRes[1], desc: tmpRes[2], install: false}
                    }
                }
            });
            resolve(res)
        });
        /!*exec('rpm -qa',(err,stdout,stderr)=>{
         if(err){
         }
         else{
         var rpmRes=stdout.split('\n');
         exec('smart search '+data,(err,stdout,stderr)=>{
         if(err){
         }
         else{
         var arr=stdout.split('\n');
         // var rpmTmpReg=new RegExp('^.*'+data+'.*','gim');
         // var tmpRpmList=rpmTmpReg.exec(rpmList);
         // console.log('###################################');
         // console.log(tmpRpmList[1]);
         arr.splice(0,3);
         arr.splice(-3,3);
         res = arr.map((item)=>{
         if(item.length>0){
         var tmpRes=/(.+?)\s-\s(.+)/g.exec(item);
         var install=rpmRes.some((rpmItem)=>{
         // var install=rpmList.some((rpmItem)=>{
         var reg=new RegExp(tmpRes[1],'gi');
         if(reg.test(rpmItem)){
         return true;
         }else{
         return false;
         }
         });
         return {name:tmpRes[1],desc:tmpRes[2],install:install};
         }
         });
         resolve(res);
         // resolve('smart balbalba');
         }
         });
         }
         });*!/
    })
};*/
let search=(data)=>{
    return new Promise((resolve,reject)=>{
        exec("dnf info *"+data+"*",(err,stdout,stderr)=>{
            if (err){
                console.log(err);
                // throw new Error(err);
                resolve()
            }
            else{
                let arr=stdout.split('Available Packages');
                // console.log(arr[0]);
                function pack(rows,install){
                    let obj={};
                    // console.log(rows.split(/description\s+:/i)[1]);
                    // console.log('#######################################################################');
                    // console.log(rows.split(/description\s+:/i)[1].split(":").map(s=>s.trim()).join('\n'));
                    obj.description=rows.split(/description\s+:/i)[1].split(":").map(s=>s.trim()).join('\n');
                    rows.split('\n').forEach((row)=>{
                        if(row.search('Name')>-1){
                            obj.name=row.split(":")[1].trim();
                        }
                        if(row.search('Version')>-1){
                            obj.version=row.split(":")[1].trim();
                        }
                        if(row.search('Size')>-1){
                            obj.size=row.split(":")[1].trim();
                        }
                        if(row.search('License')>-1){
                            obj.license=row.split(":")[1].trim();

                        }
                        obj.install=install;
                    });
                    return obj;
                }
                let availablePackets
                let installedPackets=arr[0].split('\n\n').slice(0,-1).map(rows=>pack(rows,true));
                if(arr.length>1){
                    availablePackets = arr[1].split('\n\n').slice(0,-1).map(rows=>pack(rows,false));

                }
                // console.log(installedPackets);
                resolve(installedPackets.concat(availablePackets))
            }

        })
    })
};
var command = (data, socket) => {
    return new Promise((resolve, reject) => {
        // var commandProcess=spawn('/var/www/tps-wan/conf/child_ul.sh',['smart',data.command,data.pack,'-y']).on('error',()=>{
        var commandProcess = spawn('dnf', [data.command, data.pack, '-y']).on('error', () => {
            // console.log('err command')
        });
        commandProcess.stdout.on('data', (data) => {
            socket.emit('packets:getLog', {timestamp: Date(), data: String(data)});
        });
        commandProcess.on('close', (code) => {
            // console.log("end logging");
            if (code != 0 && code != null) {
                console.log("code: " + code);
                // socket.emit("log:error",{code:"unable-to-get",id:code});

            } else {
                resolve({code: code, name: data.pack});
            }
        })
    });
    /*return new Promise((resolve,reject)=>{
     console.log('before exec','smart '+data.command+' '+data.pack);
     exec('smart '+data.command+' '+data.pack+' -y',function(err,stdout,stderr){
     console.log('some thing doing');
     if(err){
     console.log(err,stderr)
     }else{
     resolve('good');
     // console.log(stdout);
     }
     });

     });*/
};
var rpmUpdateList = () => {
    return new Promise((resolve, reject) => {
        // exec('/var/www/tps-wan/conf/child_ul.sh rpm -qa',(err,stdout,stderr)=>{
        exec('rpm -qa', (err, stdout, stderr) => {
            if (err) {
                console.log(err);
            } else {
                rpmList = stdout.split('\n');
                resolve();
            }
        })
    });
};
var smartUpdate = (data, socket) => {
    return new Promise((resolve, reject) => {
        /* updateLogProcess=spawn('smart',['update']).on("error",()=>{
         console.log('err logging smart updater');
         // socket.emit("log:error",{code:"unable-to-get"});
         });*/
        // updateLogProcess=spawn('/var/www/tps-wan/conf/child_ul.sh',['smart','update']).on("error",()=>{
        updateLogProcess = spawn('dnf', ['makecache','--refresh']).on("error", () => {
            console.log('err logging smart updater');
            // socket.emit("log:error",{code:"unable-to-get"});
        });
        updateLogProcess.stdout.on('data', (data) => {
            // console.log(String(data));
            // resolve(String(data));
            socket.emit('packets:getLog', {timestamp: Date(), data: String(data)})
        });
        updateLogProcess.on('close', (code) => {
            // console.log("end logging");
            if (code != 0 && code != null) {
                console.log("code: " + code);
                // socket.emit("log:error",{code:"unable-to-get",id:code});

            } else {
                resolve();
            }
        });
    })
};
module.exports = {
    smartUpdate: smartUpdate,
    rpmUpdateList: rpmUpdateList,
    command: command,
    search: search,
    listChannels: listChannels,
    removeChannel: removeChannel,
    addChannel: addChannel,
    installTibboChannel: installTibboChannel
};