/**
 * Created by stts on 22.07.2016.
 */


var fs = require('fs'),
    ini = require('ini'),
    exec = require('child_process').exec;
var getAppsList = function () {
    return new Promise(function (resolve, reject) {
        fs.readdir('/opt/node-apps',function(err,list){
            var promises = list.map((item)=>{
                return new Promise((resolve,reject)=>{
                    fs.stat('/opt/node-apps/'+item,(err,stats)=>{
                        if(err){
                            conole.log(err);
                        }else{
                            resolve(stats.isDirectory());
                        }
                    });
                })
            });
            Promise.all(promises).then((items)=>{
                var newList=list.map((item)=>{
                    return item;
                }).filter((item,index)=>{
                    return items[index];
                });
                resolve(newList);
            });
        });
    });
};
var status = function (list) {
    return new Promise(function (resolve, reject) {
        var data={};
        var isAutoload = function (app) {
            return new Promise(function (resolve, reject) {
                exec('/bin/systemctl is-enabled napp-' + app,
                    function (error, stdout, stderr) {
                        var re = /^enabled/i;
                        if (re.test(stdout)) {
                            resolve('enabled');
                        }
                        else {
                            resolve('disabled');
                        }
                    }
                );
            });
        };
        var isActive = function (app) {
            return new Promise(function (resolve, reject) {
                exec('/bin/systemctl is-active napp-' + app,
                    function (error, stdout, stderr) {
                        var re = /^active/i;
                        if (re.test(stdout)) {
                            resolve('active');
                        }
                        else {
                            resolve('inactive');
                        }
                    }
                );
            });
        };
        list.forEach(function (app) {
            Promise.all([isAutoload(app), isActive(app)]).then(function (res) {
                data[app] = {'active': res[1], 'autoload': res[0]};
                if (Object.keys(data).length == list.length) {
                    resolve(data);
                }
                //console.log(Object.keys(data).length == list.length);
            });
        });
    })
};
var togleCommand = function (arr) {
    return new Promise(function (resolve, reject) {
        exec('/bin/systemctl ' + arr[1] + ' ' + arr[0],
            function (error, stdout, stderr) {
                resolve()
            }
        );
    });
};
var applyConfig = function (data) {
    return new Promise(function (resolve, reject) {
        var iniData = data.data;
        //console.log(data);
        if(iniData['Service']&&iniData['Service']['CPUQuota'] && iniData['Service']['CPUAccounting']==true){
            if(!/\d+%/.test(iniData['Service']['CPUQuota'])){
                iniData['Service']['CPUQuota']+='%';
            }
        }
        if(iniData['Service']&&iniData['Service']['MemoryLimit'] && iniData['Service']['MemoryAccounting']==true){
            if(!/\d+M/.test(iniData['Service']['MemoryLimit'])){
                iniData['Service']['MemoryLimit']+='M';
            }
        }
        if (iniData['Service'] && iniData['Service']['Restart']) {
            iniData['Service']['Restart'] = 'on-failure';

        } else if (iniData['Service'] && !iniData['Service']['Restart']) {
            delete iniData['Service']['Restart'];
        }
        iniData['Unit']['After'] = 'network-online.target';
        iniData['Install'] = {'WantedBy': 'multi-user.target'};
        //console.log(iniData);
        fs.mkdir('/opt/node-apps/' + data.appName + '/conf', function () {
            var appFile=function(){
                return new Promise(function(resolve,reject){
                    fs.writeFile('/opt/node-apps/'+data.appName+'/conf/napp-'+data.appName+'.service',ini.stringify(iniData),function(err){
                        if(err){
                            console.log(err);
                        }
                        else{
                            resolve();
                        }
                    })
                });
            };
            var sysdFile=function(){
                return new Promise(function(resolve,reject){
                    fs.writeFile('/lib/systemd/system/napp-'+data.appName+'.service',ini.stringify(iniData),function(err){
                        if(err){
                            console.log(err)
                        }else{
                            resolve()
                        }
                    })
                })
            };
            Promise.all([appFile(),sysdFile()]).then(function(){
                resolve()
            });
        });
    })
};
var getConfig = function (app) {
    return new Promise(function (resolve, reject) {
        fs.exists('/opt/node-apps/'+app+'/conf/napp-'+app+'.service',function(exist){

            var config={};
            if (exist) {
                // console.log(app+' exist');
                fs.readFile('/opt/node-apps/'+app+'/conf/napp-'+app+'.service','utf8',function(err,file){
                    if(err){
                        console.log(err)
                    }
                    else{
                        config=ini.parse(file);
                        // console.log(config);
                        if(config['Service']&&config['Service']['CPUQuota']){
                            config.Service.CPUQuota=config.Service.CPUQuota.replace('%','')
                        }
                        if(config['Service']&&config['Service']['MemoryLimit']){
                            config.Service.MemoryLimit=config.Service.MemoryLimit.replace('M','')
                        }
                        resolve(config);
                    }
                });
            } else {
                fs.exists('/opt/node-apps/'+app+'/site/package.json',function(existPackage){
                    if(existPackage){
                        fs.readFile('/opt/node-apps/'+app+'/site/package.json','utf8',function(err,file){
                            if(err){
                                console.log(err);
                            }else{
                                var jsonObj=JSON.parse(file);
                                config={
                                    Unit:{
                                        Description:jsonObj.description
                                    },
                                    Service:{
                                        ExecStart:'/usr/bin/node /opt/node-apps/'+app+'/site/'+jsonObj.main
                                    }
                                };
                                resolve(config)
                            }
                        });
                    }else{
                        resolve(null)
                    }
                });
            }
        });

    });
};
module.exports = {
    getAppsList: getAppsList,
    applyConfig: applyConfig,
    getConfig: getConfig,
    status:status,
    togleCommand:togleCommand
};