/**
 * Created by stts on 11.04.2016.
 */
var ini = require('ini'),
    fs = require('fs'),
//dir = 'modules/valid/mod-www-builder/txt_Devices',
    dir = '/var/www/tps-wan/site/root/mod-www-builder/txt_Devices',
    _ = require('underscore'),
    tibbitFormFactor = {
        'h1': [],
        'h2': [],
        'c1': [],
        'c2': [],
        'm1': [],
        'm2': [],
        'ga1000': []
    }, tibbits = [],
    socketGroups = {
        "1": [
            '1', '2', '3', '4'
        ],
        "2": [
            '5', '6', '7', '8'
        ],
        "3": [
            '9', '10', '11', '12'
        ],
        "4": [
            '13', '14', '15', '16'
        ],
        "5": [
            '17', '18', '19', '20'
        ],
        "6": [
            '21', '22', '23', '24'
        ],
        "7": [
            '25', '26', '27', '28'
        ]
    },
    tibbitsName = [];
genSocketIni = function (poe) {
    tibbits = [];
    var configPOEJumper = poe;
    //var tps = ini.parse(fs.readFileSync(__dirname + '/valid/txt_Devices/boards/ltpp3.brd', 'utf-8'))
    var tps = ini.parse(fs.readFileSync('/var/www/tps-wan/site/root/mod-www-builder/txt_Devices/boards/ltpp3.brd', 'utf-8'));
    var files = fs.readdirSync('/var/www/tps-wan/site/root/mod-www-builder/txt_Devices/tibbits');
    //var tps = ini.parse(fs.readFileSync(dir + '/boards/ltpp3.brd', 'utf-8'))
    //var files = fs.readdirSync(dir + '/tibbits');
    tibbitsName = files.map(function (item) {
        return item.replace('.ini', '');
    });
    files.forEach(function (item, i, arr) {
        tibbit = ini.parse(fs.readFileSync(dir + '/tibbits/' + item, 'utf-8'));
        if (tibbit.requires !== undefined) {
            var requires = tibbit.requires.split(" ");
            var key = requires[0];
            requires = requires.slice(1).map(function (val) {
                return val.replace(/^(\+|\-)?/, "");
            });
            if (key == "+ALL") {
                requires = _.difference(tibbitsName, requires)
            }
            else {
                requires = _.intersection(tibbitsName, requires)
            }
        } else {
            requires = [];
        }
        if (tibbit.mates !== undefined) {
            var mates = tibbit.mates.split(" ");
            var key = mates[0];
            mates = mates.slice(1).map(function (val) {
                return val.replace(/^(\+|\-)?/, "");
            });
            if (key == "+ALL") {
                mates = _.difference(tibbitsName, mates)
            }
            else {
                mates = _.intersection(tibbitsName, mates)
            }
        } else {
            mates = [];
        }
        var newItem = {
            name: tibbit.name,
            form: tibbit.form.toLowerCase().replace(/t|s/i, ''),
            mates: mates,
            requires: requires,
            power: {
                p5v: tibbit.p5v,
                pp15v: tibbit.pp15v,
                pn15v: tibbit.pn15v
            },
            serial: tibbit.serial,
            poe: tibbit.poe,
            interrupt: tibbit.interrupt,
            line1: tibbit.line1,
            line2: tibbit.line2,
            line3: tibbit.line3,
            line4: tibbit.line4,
            line5: tibbit.line5,
            line6: tibbit.line6,
            line7: tibbit.line7,
            line8: tibbit.line8
        };
        tibbitFormFactor[newItem.form].push(newItem);

        tibbits.push(newItem);
    });
    var regExp = /^sock[0-9]*/;
    var res = {};
    Object.keys(tps).forEach(function (key) {
        var soc = {
            'accept': {
                'tibbit': [],
                'form': []
            },
            'lines': [],
            'serial': '',
            'interrupt': '',
            'poe': '',

        };
        if (regExp.test(key)) {
            var tibbitRegExp = /^[0-9]{1,2}/;
            var formRegExp = /((m|h|c)([1-2]{1}))/i;
            var sockId = key.replace(/^sock/i, '');
            tmpAccept = tps[key].accept.split(' ').slice(1);
            soc.accept.tibbit = tmpAccept.map(function (item) {
                return item.toLowerCase().replace(/\+|\-/i, '');
            }).filter(function (val) {
                return tibbitRegExp.test(val);
            });
            soc.accept.form = tmpAccept.map(function (item) {
                return item.toLowerCase().replace(/\+|\-/i, '').replace(/(t$|s$)/i, '');
            }).filter(function (val) {
                return formRegExp.test(val);
            });
            soc.accept.form = _.uniq(soc.accept.form);
            if (tps[key].serial) {
                soc.serial = tps[key].serial
            }
            if (tps[key].interrupt) {
                soc.interrupt = tps[key].interrupt
            }
            if (tps[key].poe) {
                soc.poe = tps[key].poe
            }
            soc.line1 = tps[key].line1;
            soc.line2 = tps[key].line2;
            soc.line3 = tps[key].line3;
            soc.line4 = tps[key].line4;
            soc.line5 = tps[key].line5;
            soc.line6 = tps[key].line6;
            soc.line7 = tps[key].line7;
            soc.line8 = tps[key].line8;
            if (sockId == 25 && configPOEJumper == 1) {
                soc.poe = 'YES';
            }
            if (sockId == 26 && configPOEJumper == 0) {
                soc.accept.form.push('C2')
            }
            if (sockId == 28 && configPOEJumper == 0) {
                soc.accept.tibbit.push('18', '21', '37')
            }
            resTmp = {};
            res[sockId] = soc;
        }
    });
    return res;
};
exports.valid = function (data) {
    var p5vP = 0;
    var p5vR = 500;
    var p5v = 500;
    var pp15vP = 0;
    var pp15vR = 0;
    var pp15v = 0;
    var pn15vP = 0;
    var pn15vR = 0;
    var pn15v = 0;
    var answer = null;
    answer = [];
    config = ini.parse(data);
    var res = genSocketIni(config.options.poe_jumper);
    if (config.options.p5v_direct) {
        p5v -= 1000;
        p5vP -= 1000;
    }
    /*
     *  var group - group id
     *  var sock - socket id
     *
     * */
    var tibbForm = function (data) {
        var form = '';
        tibbits.forEach(function (item) {
            if (item.name == config.sockets['s' + data]) {
                form = item.form;
            }
        });
        return form;
    };
    var checkOpt = function (tibb, tps, lBool) {
        if (tibb === undefined) {
            if (lBool) {
                tibb = 'YES';
            } else {
                tibb = 'NO';
            }
        }
        if (tps === undefined) {
            if (lBool) {
                tps = 'YES';
            } else {
                tps = 'NO';
            }
        }
        var reg = /OPTIONAL.*/i;
        if (reg.test(tibb)) {
            tibb = 'opt';
        }
        if (reg.test(tps)) {
            tps = 'opt';
        }
        if (tibb == 'YES') {
            switch (tps) {
                case 'YES':
                    return true;
                case 'NO':
                    return false;
                case '':
                    return !!lBool;
            }
        }
        else if (tibb == 'NO' || tibb == '') {
            switch (tps) {
                case 'YES':
                    return true;
                case 'NO':
                    return true;
                case '':
                    return true;
            }
        }
        else if (tibb == 'opt') {
            switch (tps) {
                case 'YES':
                    return true;
                case 'NO':
                    return false;
                case '':
                    return true;
            }
        } else {
            return false;
        }
    };
    if (config.sockets['s29'] && config.sockets['s29'] != 37) {
        answer.push('Tibbit #' + config.sockets['s29'] + ' incompatibility with socket 29');
    }
    if (config.sockets['sga'] && config.sockets['sga'] != 'ga1000') {
        answer.push('Tibbit #' + config.sockets['ga'] + ' incompatibility with socket ga');
    }else if(config.sockets['sga'] && config.sockets['sga'] == 'ga1000'){
        p5v+=350;
        p5vR+=350;
    }
    //console.log(config.sockets);
    Object.keys(socketGroups).forEach(function (group) {
        Object.keys(socketGroups[group]).forEach(function (item) {
            Object.keys(config.sockets).forEach(function (socket) {
                var sock = socket.replace(/^s/i, '');
                if (socketGroups[group][item] == sock) {
                    if (res[sock].accept.tibbit.length > 0 && res[sock].accept.tibbit.indexOf(config.sockets[socket]) == -1) {
                        answer.push('Tibbit #' + config.sockets[socket] + ' incompatibility with socket ' + sock);
                    }
                    else if (res[sock].accept.form.length > 0) {
                        var tibbit;
                        tibbits.forEach(function (tibb) {
                            if (tibb.name == config.sockets[socket]) {
                                var regV = /(-?[\d]+)/;
                                tmpP5v = regV.exec(tibb.power.p5v);
                                tmpPp15v = regV.exec(tibb.power.pp15v);
                                tmpPn15v = regV.exec(tibb.power.pn15v);
                                if (tmpP5v != null) {
                                    if (parseInt(tmpP5v[0]) < 0) {
                                        p5vP = parseInt(p5vP) + parseInt(tmpP5v[0]);
                                    }else{
                                        p5vR = parseInt(p5vR) + parseInt(tmpP5v[0]);
                                    }
                                    p5v = parseInt(p5v) + parseInt(tmpP5v[0]);
                                }
                                if (tmpPp15v != null) {
                                    if (parseInt(tmpPp15v[0]) < 0) {
                                        pp15vP = parseInt(pp15vP) + parseInt(tmpPp15v[0]);
                                    }
                                    else{
                                        pp15vR = parseInt(pp15vR) + parseInt(tmpPp15v[0]);
                                    }
                                    pp15v = parseInt(pp15v) + parseInt(tmpPp15v[0]);
                                }
                                if (tmpPn15v != null) {

                                    if (parseInt(tmpPn15v[0]) < 0) {
                                        pn15vP = parseInt(pn15vP) + parseInt(tmpPn15v[0]);
                                    }
                                    else{
                                        pn15vR = parseInt(pn15vR) + parseInt(tmpPp15v[0]);
                                    }
                                    pn15v = parseInt(pn15v) + parseInt(tmpPn15v[0]);
                                }

                                if (checkOpt(tibb.serial, res[sock].serial, false) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by serial port');
                                }
                                if (checkOpt(tibb.poe, res[sock].poe, false) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by POE');
                                }
                                if (checkOpt(tibb.interrupt, res[sock].interrupt, false) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by interrupt');
                                }
                                if (checkOpt(tibb.line1, res[sock].line1, true) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by line1');
                                }
                                if (checkOpt(tibb.line2, res[sock].line2, true) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by line2');
                                }
                                if (checkOpt(tibb.line3, res[sock].line3, true) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by line3');
                                }
                                if (checkOpt(tibb.line4, res[sock].line4, true) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by line4');
                                }
                                if (checkOpt(tibb.line5, res[sock].line5, true) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by line5');
                                }
                                if (checkOpt(tibb.line6, res[sock].line6, true) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by line6');
                                }
                                if (checkOpt(tibb.line7, res[sock].line7, true) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by line7');
                                }
                                if (checkOpt(tibb.line8, res[sock].line8, true) == false) {
                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatibility with socket ' + sock + ' by line8');
                                }
                                if (_.indexOf(res[sock].accept.form, tibb.form) != -1) {
                                    var sockGroup = socketGroups[group].slice();
                                    var index = sockGroup.indexOf(sock);
                                    if (tibb.requires.length > 0) {
                                        tibb.requires.forEach(function (req) {
                                            if (req == '00_3') {
                                                if (config.sockets['s' + (parseInt(sock) - 1)] == '00_3') {
                                                } else {
                                                    answer.push('ERR[]=Need tibbit ' + req + ' in socket ' + sock);
                                                }
                                            }
                                        })
                                    }
                                    else if (tibb.mates.length > 0) {
                                        if (index == 0) {

                                            if (config.sockets['s' + (parseInt(sock) + 1)]) {
                                                if (tibb.mates.indexOf(config.sockets['s' + (parseInt(sock) + 1)]) == -1) {
                                                    answer.push('ERR[]=Tibbit  #' + tibb.name + ' in socket ' + sock + ' dont work with tibbit #' + config.sockets['s' + (parseInt(sock) + 1)] + ' in socket ' + (parseInt(sock) + 1));
                                                }
                                            }
                                        }
                                        if (index == 1) {
                                            if (config.sockets['s' + (parseInt(sock) - 1)]) {
                                                if (tibb.mates.indexOf(config.sockets['s' + (parseInt(sock) - 1)]) == -1) {
                                                    answer.push('ERR[]=Tibbit  #' + tibb.name + 'in socket ' + sock + ' dont work with tibbit #' + config.sockets['s' + (parseInt(sock) - 1)] + ' in socket ' + (parseInt(sock) - 1));
                                                }
                                            }
                                        }
                                        if (index == 2) {
                                            if (config.sockets['s' + (parseInt(sock) + 1)]) {
                                                if (tibb.mates.indexOf(config.sockets['s' + (parseInt(sock) + 1)]) == -1) {
                                                    answer.push('ERR[]=Tibbit  #' + tibb.name + 'in socket ' + sock + ' dont work with tibbit #' + config.sockets['s' + (parseInt(sock) + 1)] + ' in socket ' + (parseInt(sock) + 1));
                                                }
                                            }
                                        }
                                        if (index == 3) {
                                            if (config.sockets['s' + (parseInt(sock) - 1)]) {
                                                if (tibb.mates.indexOf(config.sockets['s' + (parseInt(sock) - 1)]) == -1) {
                                                    answer.push('ERR[]=Tibbit  #' + tibb.name + 'in socket ' + sock + ' dont work with tibbit #' + config.sockets['s' + (parseInt(sock) - 1)] + ' in socket ' + (parseInt(sock) - 1));
                                                }
                                            }
                                        }
                                    }
                                    if (index == 0) {
                                        if (tibb.form == 'h2') {
                                            sockGroup.forEach(function (data) {
                                                if (config.sockets['s' + data] != undefined && data != sock) {
                                                    answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatible with other tibbits in socket ' + data)
                                                }
                                            });
                                        }
                                        if (tibb.form == 'm2' && config.sockets['s' + (parseInt(sock) + 2)]) {
                                            answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatible with other tibbits in socket ' + (parseInt(sock) + 2))
                                        }
                                        if (tibb.form == 'h1' && config.sockets['s' + (parseInt(sock) + 1)]) {
                                            answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatible with other tibbits in socket ' + (parseInt(sock) + 1))
                                        }
                                    }
                                    if (index == 1) {
                                        if (tibb.form == 'c2' && config.sockets['s' + (parseInt(sock) + 2)]) {
                                            answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatible with other tibbits in socket ' + (parseInt(sock) + 2))
                                        }
                                    }
                                    if (index == 2) {
                                        if (tibb.form == 'h1' && tibbForm(parseInt(sock) - 1) == 'c2') {
                                            answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatible with other tibbits in socket ' + config.sockets['s' + (parseInt(sock) - 1)])
                                        }
                                        if (tibb.form == 'h1' && config.sockets['s' + (parseInt(sock) + 1)].length > 0) {
                                            answer.push('ERR[]=Tibbit #' + tibb.name + ' incompatible with other tibbits in socket ' + config.sockets['s' + (parseInt(sock) + 1)])
                                        }
                                    }
                                } else {
                                    answer.push('ERR[]=Tibbit ' + config.sockets[socket] + ' not suitable for this form factor')
                                }
                            }
                        });
                    }
                    else if (res[sock].accept.tibbit.length == 0 && res[sock].accept.form.length == 0) {
                        answer.push('ERR[]= Tibbit #' + config.sockets[socket] + ' incompatibility with socket ' + sock);
                    }
                }
            });
        })
    });

    // console.log(p5vP + '-'+p5vR+'|', pp15v + '|', pn15v);
    if (p5v > 0) {
        if (p5v > 0 && p5vP != 0) {
            answer.push('WRN[]=ERROR! Current consumption on the +5V rail (' + p5vR + 'mA) exceeds the available power capacity (' + Math.abs(p5vP) + 'mA)');
        } else {
            answer.push('WRN[]=ERROR! Your configuration lacks a +5V power supply (the current consumption is ' + p5v + 'mA)');
        }
    }
    if (pp15v > 0) {
        if (pp15v > 0 && pp15vP != 0) {
            answer.push('WRN[]=ERROR! Current consumption on the +15V rail (' + pp15vR + 'mA) exceeds the available power capacity (' + Math.abs(pp15vP) + 'mA)');
        } else {
            answer.push('WRN[]=ERROR! Your configuration lacks a +15V power supply (the current consumption is ' + pp15v + 'mA)');
        }

    }
    if (pn15v > 0) {
        if (pn15v > 0 && pn15vP != 0) {
            answer.push('WRN[]=ERROR! Current consumption on the -15V rail (' + pn15vR + 'mA) exceeds the available power capacity (' + Math.abs(pn15vP) + 'mA)');
        } else {
            answer.push('WRN[]=ERROR! Your configuration lacks a -15V power supply (the current consumption is ' + pn15v + 'mA)');
        }
    }
    return answer;
};