/**
 * Created by stts on 24.05.2016.
 */
//      
const fs = require('fs'),
    ini = require('ini'),
    exec = require('child_process').exec;

const getAccessPoint = function (data    )              {
    return new Promise(function (resolve, reject) {
        fs.readFile('/etc/wpa_supplicant/wlan0.conf','utf8',function(err,wan0cfg){
            if(err){
                console.log(err);
            }else{
                let regAccessPoint = /network\s*=\s*{([^}]*)}/gmi;
                let currConnSsid;
                let fileRes = [];
                let firstArr = [];
                let scanRes = [];
                let tmpRes;
                while ((tmpRes = regAccessPoint.exec(wan0cfg)) !== null) {
                    let regPass = /#psk/igm;
                    tmpRes[1] = tmpRes[1].replace(regPass, 'showPass');
                    let cfg = ini.parse(tmpRes[1]);
                    let arr = {};
                    arr = cfg;
                    //arr.show = false;
                    arr.connected = false;
                    fileRes.push(arr);
                }
                var getWanDump = function () {
                    return new Promise(function (resolve, reject) {
                        exec('iw dev wlan0 scan dump',
                            function (err, stdout, stderr) {
                                resolve(stdout)
                            });
                    });
                };
                var wanDump = [];
                getWanDump().then(function (val) {
                    var regWpa = /bss.*\n((\s.+\n)*)/igm;
                    var resWpa
                    while ((resWpa = regWpa.exec(val)) !== null) {
                        var tmpres = {};
                        var ssidReg = /\s+ssid:\s([^\s]*)/gmi;
                        var signalReg = /\s+signal:\s([^\s]*)/gmi;
                        var capabilityReg = /\s+capability:\s(.*\n)/im;
                        var ssid = ssidReg.exec(resWpa[1]);
                        var signal = signalReg.exec(resWpa[1]);
                        tmpres['ssid'] = ssid[1];
                        tmpres['signal'] = 0 - signal[1];
                        //tmpres['show'] = false;
                        if (capabilityReg.test(resWpa)) {
                            let capability = capabilityReg.exec(resWpa);
                            if (/privacy/mi.test(capability[1])) {
                                if (/rsn/im.test(resWpa)) {
                                    let rsnReg = /^\s+RSN:.+\n(^\s+\*\s.+\n)+^\s+\*\sauthentication\ssuites:\s(.+)\n/im;
                                    let rsnAuth = rsnReg.exec(resWpa);
                                    tmpres['rsnAuth'] = rsnAuth[2]
                                }
                                if (/wpa/im.test(resWpa)) {
                                    let wpaReg = /^\s+wpa:.+\n(^\s+\*\s.+\n)+^\s+\*\sauthentication\ssuites:\s(.+)\n/im;
                                    let wpaAuth = wpaReg.exec(resWpa);
                                    tmpres['wpaAuth'] = wpaAuth[2]
                                }
                            }
                        }
                        var first = fileRes.map(function (i) {
                            return i;
                        }).filter(function (i) {
                            if (i.ssid === tmpres.ssid) {
                                return true;
                            }
                        });
                        if (first.length > 0) {
                            tmpres['psk'] = first[0]['psk'];
                            tmpres['showPass'] = first[0]['showPass'];
                            tmpres['connected'] = false;
                            firstArr.push(tmpres);
                        } else {
                            scanRes.push(tmpres);
                        }
                    }
                    var lastArr = fileRes.map(function (i) {
                        return i;
                    }).filter(function (i) {
                        let tmp = true;
                        firstArr.forEach(function (fItem) {
                            if (fItem.ssid === i.ssid) {
                                tmp = false;
                            }

                        });
                        if(i.ssid==undefined){

                            tmp= false;
                        }
                        return tmp;
                    });
                    scanRes.sort(function (a, b) {
                        if (a.signal < b.signal) {
                            return -1;
                        }
                        if (a.signal > b.signal) {
                            return 1;
                        }
                        return 0;
                    });
                    var resArray = [];
                    execCommand('iw dev wlan0 link').then(function(val){
                        if(!/^not connected.*/i.test(val)){
                            currConnSsid=/^\s.*ssid:\s(\w*)/im.exec(val);
                            firstArr.forEach(function(item,index){
                                if(item.ssid==currConnSsid[1]){
                                    firstArr[index].connected=true;
                                }
                            })
                        }
                        resolve(resArray);
                    });
                    resArray.push(firstArr);
                    resArray.push(scanRes);
                    resArray.push(lastArr);
                });
            }
        });

    });
};
const newConnect = function (data    )             {
    // console.log('socket data recive: '+data)
    return new Promise(function (resolve, reject) {
        if(data.eap){




            // console.log("EAP!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!")
            fs.readFile('/etc/wpa_supplicant/wlan0.conf','utf8',function(err,wlan0) {
                if (err) {
                    console.log(err);
                }else{
                    let network
                    if(data.eap=='tls'){
                        network =
                        'network={\n'+
                            '\tssid="'+data.ssid+'"\n'+
                            '\tkey_mgmt=WPA-EAP\n'+
                            '\tpairwise=CCMP TKIP\n'+
                            '\tgroup=CCMP TKIP\n'+
                            '\teap=TLS\n'+
                            '\tca_cert="/etc/wpa_supplicant/certs/'+data.caCert+'"\n'+
                            '\tclient_cert="/etc/wpa_supplicant/certs/'+data.clientCert+'"\n'+
                            '\tprivate_key="/etc/wpa_supplicant/certs/'+data.privKey+'"\n'+
                            '\tidentity="'+data.identity+'"\n'+
                            '\tprivate_key_passwd="'+data.privateKeyPass+'"\n}'


                    }
                    if(data.eap=='peap'){
                        network =
                        'network={\n'+
                            '\tssid="'+data.ssid+'"\n'+
                            '\tkey_mgmt=WPA-EAP\n'+
                            '\teap=PEAP\n'+
                            '\tca_cert="/etc/wpa_supplicant/certs/'+data.caCert+'"\n'+
                            '\tidentity="'+data.identity+'"\n'+
                            '\tpassword="'+data.privateKeyPass+'"\n'+
                            '\tphase1="peaplabel='+data.phase1+'"\n'+
                            '\tphase2="auth='+data.phase2+'"\n}'


                    }
                    if(data.eap=='ttls'){
                        network = 
                        'network={\n'+
                            '\tssid="'+data.ssid+'"\n'+
                            '\tkey_mgmt=WPA-EAP\n'+
                            '\teap=TTLS\n'+
                            '\tca_cert="/etc/wpa_supplicant/certs/'+data.caCert+'"\n'+
                            '\tidentity="'+data.identity+'"\n'+
                            '\tpassword="'+data.privateKeyPass+'"\n'+
                            '\tphase2="auth='+data.phase2+'"\n}'


                    }
                    var regWlan0=/(^network={\n(^\s.*\n)*})/igm;
                    var networkArr=[];
                    var networkId;
                    var tmpNetworkArr=[];
                    var strRegSsid = '^\s*ssid="' + data.ssid + '"\n';
                    var strRegNetworkId = '^(\d)\s*'+data.ssid;
                    var regSsid = new RegExp(strRegSsid, 'im');
                    var regNetworkId = new RegExp(strRegNetworkId, 'im');
                    //let network;
                    while ((networks=regWlan0.exec(wlan0))!== null){
                        // console.log("networkArr: "+networkArr)
                        // console.log("network: "+network[0])
                        if(regSsid){
                            networkArr.unshift(networks[0]+'\n');
                            // console.log("if regSSID")
                            // console.log("networkArr: "+networkArr)
                            // console.log("network: "+network[0])
                        }
                        else{
                            tmpNetworkArr.push(networks[0]+'\n');
                            // console.log("if !regSSID")
                            // console.log("networkArr: "+networkArr)
                            // console.log("network: "+network[0])
                            // console.log("tmpNetworkArr: "+tmpNetworkArr)
                        }
                    }
                    var writeArr=networkArr.concat(tmpNetworkArr);
                    wlan0=wlan0.replace(regWlan0,'').trim();
                    fs.writeFile('/etc/wpa_supplicant/wlan0.conf',wlan0+'\n'+writeArr.join('')+'\n'+network,'utf8',function(err){
                        if(err){
                            console.log(err);
                        }
                        else{
                            execCommand('wpa_cli reconfigure && wpa_cli list_networks').then(function(val){
                                // console.log('reconfigure done !!!');
                                // resolve()
                                networkId=regNetworkId.exec(val);
                                resolve()
                                /*execCommand('wpa_cli select_network 0').then(function(val){
                                    resolve();
                                })*/
                            });
                        }
                    });
                }
            })
        }else{
            execCommand('wpa_passphrase '+data.ssid+' '+data.password+' >> /etc/wpa_supplicant/wlan0.conf').then(function(val){
                fs.readFile('/etc/wpa_supplicant/wlan0.conf','utf8',function(err,wlan0){
                    if(err){
                        console.log(err);
                    }
                    else{
                        var regWlan0=/(^network={\n(^\s.*\n)*})/igm;
                        var networkArr=[];
                        var networkId;
                        var tmpNetworkArr=[];
                        var strRegSsid = '^\s*ssid="' + data.ssid + '"\n';
                        var strRegNetworkId = '^(\d)\s*'+data.ssid;
                        var regSsid = new RegExp(strRegSsid, 'im');
                        var regNetworkId = new RegExp(strRegNetworkId, 'im');
                        let network;
                        while ((network=regWlan0.exec(wlan0))!== null){
                            // console.log("networkArr: "+networkArr)
                            // console.log("network: "+network[0])
                            if(regSsid){
                                networkArr.unshift(network[0]+'\n');
                                // console.log("if regSSID")
                                // console.log("networkArr: "+networkArr)
                                // console.log("network: "+network[0])
                            }
                            else{
                                tmpNetworkArr.push(network[0]+'\n');
                                // console.log("if !regSSID")
                                // console.log("networkArr: "+networkArr)
                                // console.log("network: "+network[0])
                                // console.log("tmpNetworkArr: "+tmpNetworkArr)
                            }
                        }
                        var writeArr=networkArr.concat(tmpNetworkArr);
                        wlan0=wlan0.replace(regWlan0,'').trim();
                        fs.writeFile('/etc/wpa_supplicant/wlan0.conf',wlan0+'\n'+writeArr.join(''),'utf8',function(err){
                            if(err){
                                console.log(err);
                            }
                            else{
                                execCommand('wpa_cli reconfigure && wpa_cli list_networks').then(function(val){
                                    networkId=regNetworkId.exec(val);
                                    execCommand('wpa_cli select_network 0').then(function(val){
                                        resolve();
                                    })
                                });
                            }
                        });
                    }
                });

            });
        }

    });
};
var execCommand=function(command){
    return new Promise(function (resolve, reject) {
        exec(command,
            function (err, stdout, stderr) {
                if(err!==null){
                    reject(err);
                }
                resolve(stdout)
            });
    });
};
var forgot=function(data    )             {
    return new Promise(function(resolve,reject){
        var strRegNetworkId = '^(\\d)\\s*'+data.ssid;
        var regNetworkId = new RegExp(strRegNetworkId, 'im');
        var networkId;
        execCommand('wpa_cli reconfigure && wpa_cli list_networks').then(function(val){
            try{
                networkId=regNetworkId.exec(val);
            }catch (e){
                console.log(e);
            }
            execCommand('wpa_cli remove_network '+networkId[1]+' && wpa_cli save_config').then(function(val){
                resolve();
            })
        });
    });
};
var connect=function(data    )             {
    return new Promise(function(resolve,reject){
        var strRegNetworkId = '^(\\d)\\s*'+data.ssid;
        var regNetworkId = new RegExp(strRegNetworkId, 'im');
        var networkId;
        execCommand('wpa_cli reconfigure && wpa_cli list_networks').then(function(val){
            try{
                networkId=regNetworkId.exec(val);
            }catch (e){
                console.log(e);
            }
            execCommand('wpa_cli select_network '+networkId[1]).then(function(val){
                resolve();
            })
        });
    });
};
const getDB=function()             {
    return new Promise(function(resolve,reject) {
        fs.readFile('/lib/crda/2lc.txt','utf8',function(err,fileDb){
            if(err){
                console.log(err);
            }
            else{
                var reg= /,\n\]/gm;
                fileDb=fileDb.replace(reg,'\n\]');
                resolve(JSON.parse(fileDb));
            }
        });
    });
};
const setRegion=function(data    )             {
    return new Promise(function(resolve,reject){
        execCommand("echo \"options cfg80211 ieee80211_regdom="+data+"\" > /etc/modprobe.d/cfg80211.conf && iw reg set "+data).then(function(){
            resolve();
        });
    });
};

const getCurrRegion=function(){
    return new Promise(function(resolve, reject){
        fs.exists('/etc/modprobe.d/cfg80211.conf',function(exist){
            if(exist){
                fs.readFile('/etc/modprobe.d/cfg80211.conf','utf8',function(err,file){
                    if(err){
                        reject("no-file")
                    }else{
                        var reg=/^options\scfg80211\sieee80211_regdom=([A-Z0-9]{2})/;
                        var res=reg.exec(file);
                        if(res === null){
                            reject("unable-to-parse")
                        } else{
                            let domain = res[1];
                            getDB()
                                .then((result) => {
                                    let domainInList = result.find((item) => {
                                        return item.code === domain
                                    });
                                    if(domainInList){
                                        resolve(domain)
                                    }else{
                                        reject("not-in-list")
                                    }
                                })
                                .catch(err => reject("unable-to-read-db"))
                        }
                    }
                });
            }
        });
    });
};

module.exports = {
    getCurrRegion:getCurrRegion,
    setRegion:setRegion,
    getDB:getDB,
    getAccessPoint: getAccessPoint,
    newConnect: newConnect,
    forgot: forgot,
    connect: connect
};
